Changelog for Versions 7.0 and 7.1

Various minor corrections and updates in template files.

Added a "Relationships" button in the "Relationships" drop-down menu (m=C).
This feature includes an extended table of potential "cousin" relationships
up to an ascending degree v (v1/v2 represent ascending/descending degrees).
Note that "self" is now represented as v=v1=0 (previously 1) for consistency.
Please be aware that some translations for relationships are still pending.
A new .gwf parameter "cache_cousins_tool=yes" allow the use of a cache file
to help with loading time on big databases.

When browsing with a Sosa reference and the individual has a relationship with
the Cujus, the relationship name is now provided along with the names of common
ancestor(s) and the shortest path graph between them (m=RL). This feature also
considers half-relationships with a lone common ancestor.

The "places by surname" tool (m=PPS) on the welcome page has been updated. It
now explicitly lists persons related to a given place and offers the ability to
construct a multi-relation tree between these individuals. Additionally, a link
back to the places dictionary is provided.

A new "carousel" mechanism (m=SND_IMAGE_C) has been added, allowing for the
archival of several pictures associated with an individual, beyond the existing
portrait.

Introducing the new command m=DOC, similar to m=SRC, which now allows loading
PDF and HTML files. You can display the content of a PDF file using "<a
href="%sm=DOC&s=file.pdf">pdf file</a>". Unlike image files, PDF and HTML files
cannot be included in an <img src="..."> command. Arguments for m=SRC and m=DOC
can now be located in subfolders of the current images/basename and src/basename
folders.

Most template pages now feature new buttons to change image/spouse variables.
Portraits and spouses are now shown by default, but you can hide them by using
variables im=0 and sp=0 in the URLs.

A new bar of buttons for trees is now available at the bottom of pages. Switch
between tree types: agnatic/ascending/cognatic/descending/v/short. Navigate to
father/mother/siblings when available. The "<>" button switches the positions
of spouses (male by default on the left). "V" represents a descending tree in
template format, similar to the old one. "Short" uses Jean Vaucher's algorithm
tto reduce the width of trees.

In ascending trees, the marriage year is now replaced by a marriage-divorce or
relation-separation period, with information on widowhoods available in
tooltips.

A new parameter "visitor_access=no" in the .gwf file prevents access to the base
for anyone except friends and wizards.

The lexicon now supports an alias mechanism that allows for multiple names for
the same set of translations using "->:" (similar to language prefixes).

Accessing the server without specifying a base name opens the index.txt file.
This file allows users to capture the base name and now provides a list of all
available bases. If only one base exists, its welcome page is opened directly.

While searching, lists of homonyms are expanded with parents and spouses' names
for easier identification. The same details are shown in the merge tool (m=MRG).

If calculable, the individual's age in days is now given on the tooltip of the
icon (from templm).

In the ascendant table by couples (m=A&m=T), the middle column now displays the
number of children of the couple before the marriage event. All other spouses'
children and relations are shown in small text in blue/red (him/her). Relations
are printed in chronological order. The spouses of those other relations are
shown in the tooltip of the event, providing a better view of the various
existing families and a quick count of the total children of both ascendants.

In the Ancestors menu (m=A), the selection of generations is enhanced with
statistics, including the period of the generation, the number of added
individuals and implexes by generations, the total number of individuals and
implexes up to this generation, and the percent of completion of the generation
in the tooltip. This feature is allowed thanks to select2.min.js jQuery scripts
and may be resource-intensive for a large number of ancestors and implexes.

Individual and family forms (m=MOD_IND/MOD_FAM) now include three new components
for witnesses: an "occupation" input and two checkboxes for "maybe dead" and
"public." The types of witnesses and relationships have been extended. If "link"
is selected, a hyperlink to the witness' page is displayed.

In the authentication files for wizards and friends, the username can now be
expanded into username|userkey, where userkey is first_name.ocurence.surname of
the user in this base. This allows for a quick link to that individual after
login.

In "Books" (m=MOD_DATA), a new parameter "book_max_results" in gwf limits the
results of books, with the default set at 1000. Additionally, a new anchor
after a modification allows for a fallback to the edited entry, and a new
search input facilitates multiple corrections. Improved breadcrumb trail and
navigation are also included.

Home buttons are now set on the top right for all pages. Two new icons have
been added to facilitate debugging: - The hourglass icon indicates the CPU load
time of the gwd request, with a color indicator (green/yellow/red) based on
speed. The load time is provided in the tooltip of that icon. - The bug icon
indicates coding errors on the page, and its tooltip provides information about
the number of errors found while loading the page, including a list of
undefined variables. These new buttons can be hidden with the new gwf parameter
"hide_compilation_time=yes". Please report any issues if you encounter errors
in gwd logs/console.

The number of connected wizards/friends is now displayed on the right in the
footer, next to copyrights.

The "default_lang" parameter set in gwf is highlighted in the language select
menu if the language has been changed.

New inputs have been added in the population pyramid form, including interval
and limit, which were previously only available by modifying the URL.

A minimized monospace font based on DejaVu Sans Mono is now loaded for a better
rendering of the descending tree view, containing about 50 ASCII box-drawings
characters. The files are located at /webfonts/dejavusansmono-
genewebfont.woff/2.

The "static_path" parameter in gwf has been depreciated,
and is now set at the launch of gwd.
gwd takes three possible launch parameters:
-hd designates the location of gw. From this location
    gw/etc and gw/images can be derived.
-etc_prefix designates etc if it is not located in gw.
-images_prefix designates images if it is not located in gw
In templates, %gw_prefix;, %etc_prefix;, %images_prefix; provide these values.
These values provide the necessary directory separator when prepended to a file.
(For retro compatibility purposes, %static_path; = %etc_path; and 
%ipage_prefix = %images_prefix;)

Remove GWPREFIX not used anymore during Unix install,
as "man" pages not maintained anymore either since geneweb 7.0.0

GeneWeb version 7.0.0
---------------------

This changelog note tries to reconstruct changes in GeneWeb since version 6.08.
It may miss some details which might be added later if relevants.

- Development environment: GeneWeb's development environment has been shifted to opam+dune,
  and relies on a variety of external libraries. Dependencies are managed by opam.
  See README for installation instructions

- Code revision: GeneWeb code has been profoundly reorganised:
  - files are now separated into a /bin and /lib folders.
  - some functions have been isolated as external libraries and/or separate
    repositories (contrib, unidecode)
  - some files have been split in two parts, isolating the display functions from
    the other functions
  - front-end (GUI, API) functions and back-end (database) functions have been isolated
    to facilitate development and direct plugin of new front and back-end solutions.
  - many code factorization, optimisation and bug fixes

- Archival format: the archival (gw) format has been upgraded to gwplus. gwc v7 reads
  old .gw files, and gwu v7 can write old format files when launched with the parameter -old_gw.

- Events are now first class citizens in GeneWeb (personal events and family events).
  Events attributes are name, date, place, source and note. Witnesses can be attached to events.
  The current implementation results in redundant data in the .gw file as birth, baptism, marriage,
  death and burial are both reported in the traditional way (part of the person or family record)
  and as personal or family events.

- History: bug fixes

- GUI: the look of GeneWeb's interface has been revamped with a modern tool: html 5 and Bootstrap,
  resulting in a better compatibility between screen formats (PC, tablet, phone).
  Icons are display as font elements rather than images.

-Templates: templates have been revised in multiple fashion
  - new templates (H and I trees, family tree, ascendant and descendant tables)
  - the variety of templates (a, b, c, ...) has been collapsed into a mechanism allowing
    interactive selection of modules to form a page (left-most icon on the menubar).
    Modules include identity, unions, parents, grand-parents, relations, notes,
    sources, chronology and various trees.
    Each module may take several forms inspired by the old a, b, c, .. templates.
    A standard mechanism allows to add private modules.
    A .gwf variable (p_mod) allows memorization of a particular module configuration
    for a given base (see a.gwf for details).
  - whenever possible, clickable items on a page point to the designated person
    (first_name surname), its update page (sex of dates), its family update page (marriage date).

- Advanced search: the advanced search page, and the underlying search mechanisms have
  been updated for generality and efficiency. This is an ongoing effort.

- Notes safety: enhanced mechanism to prevent introduction of malicious code in notes.

- Gwsetup: updated to include more options and more tools (connex, gwdiff, gwfixbase)

- gwd: new launch parameters
  - various API related parameters
  - trace_templ -> Brackets template files with begin/end html comments (<!-- begin xxx ->)
    including the full path name of the file

- gwf:
    new variables in the gwf file are described in the a.gwf default configuration file

GeneWeb version 6.08
--------------------

* Added scripts created by Daniel. See contrib/gwbase.
* Mainly, bug fixes.

GeneWeb version 6.07
--------------------

* Added a detailed history. It allows you to compare two modifications of an
  individual and see what have changed.
* New design for the search form in the welcome page. Instead of 3 radio
  buttons, there is now 3 input text. The first one allow you to search by
  first names. The second one by names. The last one by key (first name.occ
  surname), public name, alias, sosa ... One trick is possible, you can
  enter first name(.occ) and name in the respective field and it will search
  by first name and surname.
* Added the warning BigAgeBetweenSpouses, DeadOld (if dead after 1900 and aged
  of 105 years old or if dead before 1900 and aged of 100 years old),
  OldIndividual (if not dead and aged more than 120 years old). Specify if the
  warning "marriage before/after birth/death" applies to a witness or a couple.
* Fix import Gedcom option for uppercase/lowercase name when using utf8.
* New output : missing events.
* Other small things...


GeneWeb version 6.06
--------------------

* ! New ! You can try the new graphical interface of GeneWeb. It's supposed
  to replace gwsetup at the end. Right now, it's a beta version so every
  thing is not finished yet. Feedback is welcome.
* Add three new warnings : ChangedOrderOfMarriages, CloseSiblings and
  ParentTooOld. Activate the warning YoungForMarriage.
* Change totally the way to notify and record the changes of a base. There is
  now only one variable in your gwf file (notify_change) so you should update
  your script if you were using notify_delete and notify_key. You should then
  test in your script notify_change the kind of action : "dp" -> delete person
  (see upthist.txt for the complete list of action) ...
  The order of the argument are : base wizard action [variable arguments]
  In the variable arguments, you may have :
    - KEY old_key new_key
    - VISIBLE key boolean
  This modification should allow in a close future to be able to see what was
  exactly modify in a person/family (eg: birth place, marriage date ...).
* Add a "book of sources" and "book of occupations" just like the "book of
  places". The three functions uses the same variable in the gwf file:
  max_nb_updates (you should then update your gwf files). This variable
  allows to set up the maximum number of updates that can be done at a single
  time.
  Plus, this page is available as a template. For those who changed the values
  in updind and updfam template for the fields place, source, occupation,
  beware to put the right value in the upddata template.
* Add a field in the advanced request to search in the marriage information.
  This is just a small evolution, it is not meant to add other searching
  fields again and again.
* Add the occupation in the edition of a family form. One can create a
  family and specify the occupation of the father/mother and the children.
  This is again a small evolution, it is not meant to add other fields again
  and again.
* Add two new outputs : "liste-éclair" (Tiny tafel) and "book of ascendants".
* "Better" display in the ascendants/descendants menu/list/tree and the
  relatives outputs. Add a few new options in the ascendants/descendants
  list/tree.
* The way a date is displayed is now completely depedant of the "date order"
  in the language dictionary. For example, if your date order is dd/mm/yyyy,
  your date will be 01/02/1880. If instead it's d/m/yyyy, it will be displayed
  as 1/2/1880. Format accepted now are :
  - dmyyyy
  - mmddyyyy
  - yyyymmdd or yymmdd
  - ddmmyyyy or ddmmyy
* Add the evaluation functions of a date (year, month, day, prec) in the
  template (interpreted by perso.ml).
* Display the history of updates in a table.
* Other small things...


GeneWeb version 6.05
--------------------

* Optimization of the sosa computing in the template. Can be 3 to 40 times
  faster (mainly with the option display_sosa=yes).
* New organization of the relationship computing page. Cousin and Relation
  are now in the same page. Should be easier to use (javascript must be
  activated).
* New output in the ascendants and descendants menu : display in table.
* Added a link to browse in the descendants tree as in the ascendants tree.
* Added a warning in case the source field is not complete. Beware, it may
  not behave as you think.
  In order not to spoil the display, the warning will be display only like
  this :
    if there is any family sources then OK (no warning)
    else
      if there is any individual sources for him AND her then OK (no warning)
      else Warning missing sources
* Add a warning if a witness is born/dead after/before marriage.
* If you define a "sosa ref" in your gwf file, then GeneWeb will keep the gwf
  file up to date when the user modify the base (and potentially this
  individual).
* Added the notify_key when changing the name of the children and check if
  the "sosa ref" has changed.
* In case of homonyms (creation of individual/family), display the spouses of
  the homonyms in the list.
* When searching for a surname, the more there is answers the more the result
  will be displayed in many columns.
* New template : annivmenu.txt. This page contains all the links related to
  an anniversary (birth, marriage, death...)
* Lifting of gwsetup. I hope the menu is a bit clearer.
* Some modifications in perso.txt (modify menu ...)
* Add the option -add_lexicon to dictionaries.
* Add the option -nopicture in order not to import picture of GEDCOM/GW.
* Added the template of the 5.02 version (named templ502).
* Update copyright
* Update lex_utf8.txt.
* Delete file README and INSTALL that pointed to an old documentation.
* Various fixes.

Dominique DERAM :
* Update of template A, B, C, D, F, H :
** New directory templx for the templates anclist, ancsosa, anctree.
   It will be used by the template a, b, c, d, f, h.
** Update copyright
** Various fix of minors bugs and improvements.

Mickaël Rouesné:
* Update of template M :
** css.txt : refactoring of the css.
** perso.txt :
     - Display the number of ascendants and descendant.
     - If misc=on (in the gwf file) or opt=misc (in the URL), then display the
       wiki links, index and ID (reference key) of the individual in the
       bottom of the page.
     - Vertical Family Tree with 4 generations.
     - Open the update individual/family form in a new page and automatic
       reload after clicking on the [x] at the bottom of the page.
** ancmenu, ancsosa, anclist, anctree : fix bug in evar.v.
** ancsosa : improve the surname list, add occupations, update style.

GeneWeb version 6.04
--------------------

* You can now custom (more easily) the template perso by setting the right
  variables in the gwf files.
  Have a look at this page for the full documentation :
  http://opensource.geneanet.org/projects/geneweb/wiki/En_template#Personnaliser-les-fiches-individu
* Template perso.txt : the update menu is now in the top of the page and split
  into :
  - update this person (shortcut to update this person directly)
  - update menu (the classic menu)
* Variation of the favicon in the templates : perso, ancmenu, updmenu, relmenu,
  desmenu, cousmenu. Display the sex of the person as favicon.
* Added the age of the individual in perso.txt
* New search of the template files. This is now longer needed to copy the
  template files in the base. This evolution is backward compatible and
  works like this :
  - search in base/etc/mybase/name.txt
  - search in gw/etc/template/name.txt
  - search the first default template according to the template variable (gwf)
* Notify_key is now called each time an individual is modified AND his key has
  changed. This is basically in the Modify individual and Merge individual.
* Added a notify_delete that works just like notify_key
* Added a nofollow option on the link in the search page (the number of
  branches and the 'o' to fold/unfold.
* Update lex_utf8 and the particules files. The last one is now the same as
  the generated (by GeneWeb) one.
* Added 'area' and 'map' in the default HTML tags
* Added an option in the ged2gwb tool. It behaves like previously, i.e. default
  relation for a couple is Married. If someone prefer, one can use the option
  -rs_no_mention to set the relation status to NoMention.
* Added a new instruction in the template language : FOR.
  It is a simple instruction, and could be improved later but for now it works
  like this :
  for (i=MIN; i<MAX; i++) => in template language : %for;i;MIN;MAX .... %end;
  You can define any variable for iterator and you can used it in the loop. This
  variable lives only in the loop. Thus it behaves like this :
  %let;i;42%in
  %i;
  %for;i:0:10;
    %i;
  %end;
  %i;
  OUTPUT => 42; 0; 1; 2; 3; 4; 5; 6; 7; 8; 9; 42
* Added an option to *not* try a getHostByName. Could slow down on windows.
  One should add -no_host_address to gwd to use this feature.
* New implementation of the function that calculate if a person has a sosa
  number or not. Much more efficient than the previous one !
* It is now NOT possible to add or modify a family in which the first
  name or the surname of a person is not specify. => It can break the
  generation of the gw file.
* Added a return button when there had been an error in a modification
  of a person or a family.
* Fix the wedding anniversary list only if the couple is not divorced
* Added an "happy birthday" for the wedding anniversary in the
  individual page
* Added the operator '/' (DIV) in the template language
* Fix the calculus in case there is more than a thousand number in templm
* Fix the duplicates of address in gwc2. Now the book of places if
  working completely in gwc1 and gwc2

Daniel de Rauglaudre:
* Fix bug (limitation of the int size in OCaml). Now in 64 bits architecture,
  the maximum number of persons is more than 18 billions (in 64 bits only !!)
* Added an option to limit the computation time of the consang

Ondrej Blazo:
* New language available (Slovak) thanks to him !

Ludovic Ledieu:
* Fix the searching path for template in the CSS

Mickaël Rouesné:
* Fix the wrong display of tag <hr> with IE.
* Update of template M :
  ** delete file updhist.txt
  ** added calendar.txt : link to statistics, pyramid of age, anniversary,
     if calendar is republican, display the full date
  ** added the languages in welcome.txt
  ** ancsosa, deslist : added the divorce date, and state
  ** ancmenu, desmenu : added the first_name alias
  ** updfam, updind : refactoring and added javascript controller
  ** trl : added the link to the other templates

GeneWeb version 6.03
--------------------

* Added an option to authorized or not the wizards notes. By default,
  notes are not allowed. One must specified
  authorized_wizards_notes=yes in the gwf to allowed them.
* Added the tool update_nldb to update the wiki's note in the database
* Fix bug in the access rights of a person's occ. It was possible to
  have an invalid request in a relationship calculus.
* Delete some duplicates files (README/LISEZMOI/LICENCE)
* Added gwc2 and ged2gwb2 in the gwsetup tool
* In the advanced search, if the number of results is more than the
  max defined, then it display the "max first" results instead of "too
  many results"
* Added a book of places (see a.gwf to specify the maximum number of
  event that can be corrected in one pass.
  !!! Beware !!! This functionality is not completely functional when
  using gwc2. You can not edit twice the same place. If you want to
  edit more than one time one place, you have to do a consang between
  each modifications (because it will recalculate the indexes).
* Fix the regression of rtl/ltr display in some pages
* When using ged2gwb, the status of a family is now by default
  NoMention.
* Added the sosa picture in the advance search
* In the place/surname search, one can now search only for baptism or
  burial (which was before included in birth and death).
* Display the picture of an individual inline instead of attachment
* In the surname search, if the surname was not found, display the
  results in ncols (you can specify it directly in the URL: ncols =x).
* Added spouse (if exists) in the descendants tree
* various source code refactoring
Ludovic Ledieu :
* Fix the truncate name and uncaught exception : end of file in the
  forum
* Interpretation of the 'is_invisible' variable in the updhist.txt template
* Better management of the variable 'referer' (link to welcome and
  previous page)
* New implementation of the 'place/surname' request that corrects the
  html errors
* New implementation of CSS as a template (css.txt)
* Tree displaying (dag and RL) compliant with XHTML
* Better W3C compliance
* Fix wrong display for advanced request in welcome page
* rewrite old templates so that they uses common language :
  index.txt, moved.txt, redirect.txt, renamed.txt,
  robot.txt (no favicon, no image, no css since the client has no access)
Dominique Deram :
* Update templates a, b, c, d, f, and h
Mickaël Rouesné :
* Update template m

GeneWeb version 6.02
--------------------

* In the population pyramid, display an image instead of &nbsp. The purpose is
that it can be printed now.
* Added a patch in the calculus of the sosa until the number of person in the
database is well managed.
* Some esthetic changes
* Change "href=#" by "void" because internet explorer doesn't support it (go
to the top of the page).
* Fix bug (in the source code, not the template) in updating a death date from
OfCourseDead to Dead if there is actually a date of death.
* Deleting the documentation (DOC and WDOC) and the associated request.
* Added an option to activate/deactivate the forum.
* Added an option to turn on/off the counter for visiting web pages.
* Change the order of displaying the note/source in the individual page. The
family note/source comes before the information of death of the individual.
* Added execution rights to configure and camlp5_comm.sh. Geneweb can now be
compiled out of box (I mean after svn co).
* Fix bug in the GeneWeb server in CGI mode. Should not answer 200 OK.
* Fix bug in the death date by merging two individuals.
* Add a function to delete bad characters (such as ':') in the first name and
surname (that compose the key) and broken the links.
* Added template of Dominique Deram and Mickaël Rouesné.
* New implementation of the surname search function. There is now no
differences between capital letters, accent ...

GeneWeb version 6.01
--------------------

For this version, you will not find a tag of GeneWeb 6.01 because I forgot it.
Few changes since 6.00 (which was set up to start a new development of
GeneWeb).
* Add an option to display the day of a date.
* Add notes/sources in the descendants list.
* Fix bug creating a loop when adding a family and creating a father and mother
bug linking the child to his parent (with the same name of course !).

GeneWeb version 6.00
--------------------

Sorry, I forgot to add the "new" feature for this version. Hopefully there
is basically no new feature.

* Add a picto sosa next to a person after a research (by first name/surname).
* Fix bug in hiding individual of the same family.
* Fix bug in showing individual by first name whereas there were hidden.
* Use of css sheetstyle to customize the pages.

GeneWeb version 5.02.0
----------------------

* [17 Jan 2011] Fixed compilation problem if using Camlp5 version < 5.12.

GeneWeb version 5.02
--------------------

* [10 Mar 2009] Fixed bug: in arch 64 bits, databases built with gwc2
  did not work.
* [21 Jan 2008] In merge individuals, adding warning message if the
  order of the siblings of the first individual has changed due to
  possible birth date added by the second individual.
* [09 Jan 2008] Fixed bug in "relationship by marriage" when there
  are relations with persons of same sex and for languages having
  differences for the term "spouse" depending on the sex. The term
  was incorrect (using "husband" instead or "wife" or "wife" instead
  of "husband").
* [08 Jan 2008] In death cases, added case "of course dead": like
  "dead don't know when", but 1/ inferred when the person is very very
  old but don't have a death date 2/ the text "dead" is no displayed
  in personal pages.
* [08 Jan 2008] In update family form, added ability to put "p" in the
  birth year field to specify "public".
* [07 Jan 2008] In forum, when moderated, added displaying of wizard's
  messages not yet validated (in red) to allow them to possibly delete
  them.
* ... other things added, modified or fixed. These changes were not recorded
  here, because laziness...

GeneWeb version 5.01
--------------------

* New database system with command gwc2.
* Numerous small improvements and bug fixes.

GeneWeb version 5.00
--------------------

Preliminary remark: I neglected to record the changes between January
2005 and July 2005, but there are a lot of them... I complete the
missing part when I have some time (and some courage).

Feb 2007 : the courage have not continued... the changes done since
several months have not been recorded.

This Version allows to mix pages in different languages (using utf-8
encoding). Databases version <= 4.10 can be read but still in old
encoding. By re-creating the database, the new encoding is set.

The new version number (5.00) is in honour of this new encoding.

* New features : Wiki syntax and miscellaneous Notes
  - [06 Oct 05] It is now possible to use a specific ("Wiki") syntax
    inside database notes, individual notes, wizard notes and database
    forum. It is also possible to add new "miscellaneous notes". The
    syntax is close to the one used by Wikipedia (see Web). In database
    notes and wizard notes, an automatic summary is displayed. Wiki syntax
    and HTML syntax can be both used in the same page. The Wiki syntax is:
    - Lines starting with from 1 to 6 '=' and ending with the same number
      of '=' are section titles (1 = most important.. 6 = less important).
      If the text is modifiable, they can be independently editable (a
      link "(modify)" is displayed to allow it).
    - An empty line makes a new paragraph.
    - Group of at least 2 lines starting with space and with an empty
      line before and after the group of lines are displayed are they
      are with a fixed size font.
    - Lines starting with one or several '*' are list items. The number
      of '*' is the list level (must start with one '*' then two '**' etc.)
    - Lines starting with one or several '#' are numbered list items.
    - Lines starting with ':' are indented.
    - Lines starting with ';' return to new line; if the line contain ':'
      the part after that ':' is displayed indented in a new line
    - Text between '' are displayed in Italic.
    - Text between ''' are displayed in Bold.
    - Text between ''''' are displayed in Bold-Italic.
    - Text between { and } is displayed with GeneWeb highlight (bold green
      by default).
    - Characters ' [ ] { } can be displayed as they are if prefixed by %.
    - The syntax [[first_name/surname/oc/text]] makes a link to the
      individual with key (firstname, surname, oc) with 'text' displayed.
      Simplified syntaxes: if oc = 0, [[fn/sn/t]] can be used, and
      [[fn/sn]] is equivalent to [[fn/sn/0/fn sn]].
    - The syntax [[[name/text]]] makes a link to a "miscellaneous note"
      (new feature), an independent page which can be edited (if updating
      allowed), and using Wiki syntax also. The page name is 'name' (only
      letters, digits and '_' allowed) and 'text' is displayed as link. If
      the page does not exist, the link is displayed in red. These new
      pages are saved by gwu only if they did not become isolated (= no
      more linked by database notes, individual notes, wizard notes nor
      another (recursively) linked miscellaneous note). Simplified syntax
      [[[name]]] displays 'name' as link text.
    - If there is a line containing '__NOTOC__' the summary is not displayed.
    - If there is a line containing '__TOC__' the summary is displayed at
      this place instead of the default place.
    - If there is a line containing '__SHORT_TOC__' a short summary is
      displayed.

* GeneWeb server or CGI (gwd)
  - [30 Jan 06] In displaying ancestors by tree, added the ability
    to have the marriage date between the spouses.
  - [10 Nov 05] The ancestors and descendants page displays the number
    of persons in the menu.
  - [16 Oct 05] Added a system for list of only allowed nobility titles.
  - [06 Oct 05] The database forum can be moderated.
  - [02 Sep 05] Added a "search" form in database forum.
  - [17 Aug 05] The pages "statistics", "history of updates", "database
    forum", "calendars", and some pages displaying relationship links by
    trees are now customizable. They resp. use the template files
    "stats.txt", "updhist.txt", "forum.txt", "calendar.txt" and "dag.txt".
  - [23 Jul 05] All "ancestors" pages are now customizable. Depending to
    the kind of page, they use the new template files: "ancmenu.txt",
    "ancsosa.txt", "anctree.txt" and "anclist.txt".
  - [02 Jan 05] Each complete date has a link to the calendars page.
  - [20 Dec 04] Fixed bug: in display places/surnames, when vars are used
    in base configuration file (base.gwf), the alphabetical order was done
    before the vars substitutions.

* GeneWeb compiler (gwc) and GeneWeb uncompiler (gwu)
  - [13 Jul 05] Wizards notes are now saved and restored.

* GeneWeb databases Transfer Program (gwtp)
  - [08 Jan 05] Fixed bug: databases created by version 4.10 could
    not be uploaded.

GeneWeb version 4.10
--------------------

* Languages
  - [29 Jan 04] Added "Breton" (Tepod Gwilhmod, Gwenael Emelyanoff,
    Bertrand Yeurc'h).

* GeneWeb server or CGI (gwd)
  - [06 Nov 04] In statistics, added displaying of oldest couples perhaps
    still alive and engaged.
  - [06 Jan 04] Fixed bug: when changing a child's name using "change
    children's names", the possible image was not renamed, causing
    its disparition.
  - [05 Jan 04] Added database configuration variable "show_consang":
    when set to "no" the possible consanguinity is not displayed in
    personal pages. Added also variable "fast_alphabetic": when set
    to "yes", the alphabetic display of surnames or first names is fast
    but the number of surnames of fist names is not displayed (interesting
    for large databases).
  - [04 Dec 03] Fixed bug: in case of two wizards make changes at
    the same time, there were (rare) cases where one of the changes
    erases the other one (instead of being rejected by the message
    "database is locked").
  - [29 Nov 03] Added optional "border" and "background color" for
    trees displaying (relationship links, ancestors and descendants).
  - [28 Nov 03] Fixed bug creating sometimes dates with null month
    (and not null day) resulting problems with "gwu-gwc" and "cleaning
    up" the database by gwsetup (happened when a date was entered
    with month=13 which was erroneously not rejected).
  - [18 Jan 03] Added a system of black list for the database forum;
    the environment variable "forum_exclude_file" can be set to a
    file name containing a list of excluded IP addresses which cannot
    post. In the lines of this file, the joker character "*" can be
    used to specify any string (e.g. "*" exclude everybody).
  - [14 Jan 03] In form to add message in the database forum, added
    buttons "private/public": only "wizards" and "friend" can see
    "private" messages.
  - [06 Jan 03] In welcome page, added wizard's name (when named).

* Base configuration files (base.gwf)
  - [19 Mar 03] Added a variable "moved" to indicate that the database
    has been moved. This displays the new template file "moved.txt".

* Setup program (gwsetup)
  - [12 Nov 03] Fixed bug: the links to the documentation did not work
    with modern browsers.

* GeneWeb uncompiler (gwu)
  - [12 Feb 03] Fixed bug: exporting bad format when places containing
    just spaces.
  - [11 Feb 03] Added option -maxlev to specify a maximum number of
    generations (descendants only) to export.

* GeneWeb databases Transfer Program (gwtp)
  - [08 Dec 03] Added German (Falko Trojahn).
  - [14 Oct 03] Added Spanish (Luis Mondesi).
  - [03 Jan 03] Fixed bug: when wizard notes, the "send database" did
    not work.

GeneWeb version 4.09
--------------------

* GeneWeb server or CGI (gwd)
  - [30 Dec 02] Fixed security hole existing since a long time. People
    are invited to download this new version.
  - [26 Dec 02] Changed the filtering of HTML tags: in version 4.08, the
    principle was changed so that some tags were accepted and all other
    ones refused. Return to previous behaviour (some tags are refused,
    all other ones are accepted), except for the forum of the data base
    where the new behaviour is maintained.

GeneWeb version 4.08
--------------------

* Languages
  - [26 Nov 02] Added Romanian (Erich Müller).
  - [12 Nov 02] Added Bulgarian (Dimiter Skordev).
  - [11 Sep 02] Added documentation in Italian (Latino Imparato).

* GeneWeb server or CGI (gwd)
  - [09 Dec 02] Added link "wizard/notes" in welcome page to allow
    each wizard to set and modify his personal notes for the database,
    which are visible by everybody. Works only if the wizards are defined
    in a file defined by the variable "wizard_passwd_file" of the
    database configuration file.
  - [01 Dec 02] Added ability for named wizards (wizards defined in a
    wizard password file) to remove the messages they posted.
    messages in the database forum.
  - [14 Nov 02] Fixed bug: in database notes updates, there was no check
    that the update form was up to date: it was then possible to submit
    old versions, and there was no conflict access check (that two wizards
    try to change the notes at the same time).
  - [08 Nov 02] Fixed bad (strange) displaying of French Republican
    and Hebrew dates when the precision is not "Sure".
  - [06 Nov 02] In family form, one can now set the sex of created
    witnesses.
  - [30 Oct 02] In places/surnames pages, now the surname links point
    to the surname, not to a person holding this surname associated with
    the place: it is less useful but too many people blamed me that it
    was a bug. Old behaviour if the base configuration variable
    "place_surname_link_to_ind" is set to "yes". Configurable by the
    gwtp interface.
  - [23 Oct 02] In families forms, added shortcuts for created
    persons' dates: one can write: "?year" to indicate "perhaps",
    ">year" or "year/" to indicate "after", "<year" or "/year" to
    indicate "before", "/year/" to indicate "about". And in the "death"
    field, one can write "+" to indicate "died don't know when", and "-"
    to indicate "alive".
  - [10 Oct 02] The GeneWeb logo in bottom of pages is now clickable
    and return to the database welcome page.
  - [02 Oct 02] In displaying by surname, added ability to mask
    children: the families are prefixed by a clickable "o": when clicked,
    the same page is displayed but without the children of that family,
    and a clickable "+" is displayed at the place of the "o".  Useful for
    big families, when it is often not easy to see the siblings.
  - [12 Sep 02] Fixed bug: in relationship by "shortest path", the
    selection "include spouses" was not reported when trying the
    next path.

* Lexicon (lang/lexicon.txt)
  - [28 Nov 02] (Technical point for translators in GeneWeb languages)
    Changed entries "the father-in-law/the mother-in-law", "a son-in-law/a
    daughter-in-law" and "a brother-in-law/a sister-in-law": now the
    entries can have 4 values to separate the cases when they are 1/ "of a
    man" 2/ "of a woman", some languages (e.g. Bulgarian) making the
    distinction.

* Gedcom to GeneWeb (ged2gwb) and GeneWeb to Gedcom (gwb2ged)
  - [14 Nov 02] Fixed bug: relation date and place of unmaried persons
    were not imported.
  - [08 Nov 02] Fixed bad imports and exports of non Gregorian dates
    intervals.

* Templates files (etc/*.txt)
  - [25 Oct 02] For perso.txt, added macros: "file_exists_nnn"
    returning true (for a "%if") if the file nnn exists; and
    "key" returning the person's key.
  - [19 Sep 02] Changed the template file "perso.txt" to decompose the
    macro "married_to" into the different parts of this text, allowing
    to present it differently.

* Base configuration files (base.gwf)
  - [22 Oct 02] Added configuration variable public_if_no_date: all
    persons having no date are considered as public, except if their
    "access" field has been explicitly set to "Private" (default: no).
  - [22 Oct 02] Added configuration variable propose_place_surnames to
    propose or not the displaying by place / surnames in the welcome
    page (default: yes).
  - [31 Aug 02] Added configuration variable max_cousins_level to specify
    the maximum level of displayed cousins (default: 5)

* GeneWeb compiler (gwc) and GeneWeb uncompiler (gwu)
  - [22 Oct 02] Fixed bug: when cleaning up a database, if the images
    file names started with numbers (eg. 123abc.jpg), they were restored
    with an underscore at the beginning (eg. _123abc.jpg).

* Installation
  - [01 Nov 02] Added (Unix) "man" pages (installed by "make install");
    built by Christan Perrier (thanks to him!).
  - [31 Oct 02] When building GeneWeb from source files: added a "make
    install" which installs the executables in /usr/bin and the system
    files in /usr/share/geneweb. Added also "make uninstall" which undoes
    it.

* Documentation
  - [31 Oct 02] In the "modifications" chapter ("How to make modifications
    in the database), added a section (5.9) for dates shortcuts in the
    families forms (French and English versions only).

GeneWeb version 4.07
--------------------

* Languages
  - [18 Jun 02] Added Italian for gwsetup and gwtp. Corrected some
    phrases in lexicon (Latino Imparato).
  - [11 Apr 02] Added Slovenian (Mitja Iskric).

* GeneWeb server or CGI (gwd)
  - [15 Jul 02] Added ability to specify a size of images, for the ones
    which are hosted in another site. The syntax is the name of the image
    followed by "(widthxheight)". Code by Ludovic Ledieu.
  - [20 Jun 02] For option -wd (directory for socket communication and
    access count), build now all upper directories of the path (e.g.
    under Windows, if using -wd C:\TEMP\GENEWEB, build C:\TEMP if it does
    not exist).
  - [23 Apr 02] Fixed bugs: in fast merge, some fields were sometimes lost.
  - [18 Mar 02] Had to remove the cookie system added in previous version
    because it introduced a bug: the system of global authorization file
    (variable "auth_file" of the configuration file) did not work any
    more (it is complicated to make both systems work: the code is too
    badly written).

* GeneWeb compiler (gwc)
  - [22 Apr 02] Fixed bug: failed when a string contained a backslash
    followed by a space (this failure could happen for example in a
    "cleanup" of a database, which calls gwc).
  - [23 Mar 02] Fixed bug: failed at end of creation of database when
    the target database (option -o) was indicated by an absolute path.

* Gedcom to GeneWeb (ged2gwb)
  - [16 May 02] Added option -us: uppercase surnames.

* Base configuration files (base.gwf)
  - [15 Jul 02] Added variable "no_image_for_visitor" to specify not
    to search images when "normal" visitor (i.e. neither "wizard", nor
    "friend"). Useful if the images are hosted in a site protected by
    a password (htaccess). Code by Ludovic Ledieu.

GeneWeb version 4.06
--------------------

* Installation
  - [08 Mar 02] In MacOS X version, there is no more need to do extra
    manipulation after installation to make the command GeneWeb work.
  - [06 Mar 02] In Windows version with installer, it is now possible to
    specify the database directory.

* GeneWeb server or CGI (gwd)
  - [06 Mar 02] Fixed problem of the text "marriages and children" in
    Spanish, "casamientos e hijos", which were incorrectly displayed
    "casamientos y hijos". Technical: the solution uses a system of
    "elision" (already needed by Catalan) which had to be a little bit
    modified.
  - [05 Mar 02] Fixed bug, in personal page: the circle before
    children was supposed to be empty for the non married ones and full
    for the married ones, but it did not work in all browser. Technical:
    it was due to the <li> item type, wrongly written "disk" instead
    of "disc".
  - [05 Mar 02] Fixed bug: the navigation supposed to avoid the
    "reloading" of pages (proposed in bottom of welcome pages) did not
    work immediately after updates.
  - [04 Mar 02] In CGI mode, in welcome page, the wizard and friend
    entries are now accessible by links, like in server mode, instead of an
    input form. Moreover, if cookies are accepted, when navigating, there
    is no visible "token" in the URL. If cookies are not accepted, the
    behaviour does not change.
  - [03 Mar 02] Fixed bug (introduced in version 4.05): in CGI mode,
    the images (logo, background, flags) did not appear, because they were
    incompletely sent (a solution to turn around this bug is to use the
    option -images_url). There is the same problem with the "DOC" link,
    the same fix works also for it, but there is no way to turn around it
    in version 4.05.
  - [02 Mar 02] Fixed bug: when clicking on somebody's link, could sometimes
    access the wrong person, typically when the two persons had the same
    combination "firstname surname" cut differently, e.g. François-Victor
    Hugo (first name "François-Victor", surname "Hugo") and François
    Victor-Hugo (first name "François", surname "Victor-Hugo").

* Gedcom to GeneWeb (ged2gwb)
  - [08 Mar 02] Fixed bug: the import added 5 empty lines at end of
    each person's notes.

* Setup program (gwsetup)
  - [06 Mar 02] Added "cancel" buttons close to some "ok" buttons.
  - [05 Mar 02] Updated German in templates (Thomas Omerzu).

GeneWeb version 4.05
--------------------

* GeneWeb server or CGI (gwd)
  - [26 Feb 02] Added the ability to set the variable "motd" in the
    database configuration file which is displayed in the welcome page.
  - [26 Feb 02] Fixed bug: when updating a person whose death date was
    indicated as a "text", the death menu displayed "alive".
  - [24 Feb 02] Fixed problem of wizard and friend connections under
    CGI mode which sometimes did not work. Technical features: it was due
    to the fact that in kind of internet connections, the origin internet
    address can change for the same user, resulting on no more wizard or
    friend connection. Now the origin internet address is no more checked,
    only the given token is.
    only the given token is.
  - [24 Feb 02] Fixed the problem of "disconnection" when (typically)
    inserting children in a family. Seemed to happen more and more often
    with recent versions of Windows Web navigators (symptoms: doing
    "update", "modify family", clicking in an "insert child" button, and
    doing "ok": then the browser says that the server has disconnected the
    connection).
  - [14 Feb 02] Now the header and trailer files (base.hed and
    base.trl) can be in only one examplary for all languages in the
    directory lang (of databases directory) with the ability of inline
    translation like in start.txt. Still searches first in subdirectories
    of the language identifier, for compatibility.
  - [02 Feb 02] Fixed bug: when merging two persons, in case of fast
    merge applied, some fields of the second person were lost (notes,
    baptism).
  - [02 Feb 02] Added an indication "wizard" or "friend" in upper
    right corner of the welcome page.
  - [31 Jan 02] Added a system to restrict access more strict than the
    "hide_private_names" system. It can be set by setting the variable
    "use_restrict" to "yes" in the configuration file. In this context,
    the hidden persons are not clickable and the relationship computing
    cannot go through them. (Implemented by Ludovic Ledieu.)
  - [30 Jan 02] Fixed (hope so!) displaying of relationship by shortest
    path in case of half siblings: sometimes intermediate parents were
    missing, introducing confusion.
  - [21 Jan 02] Added a link to the "gwsetup" service in bottom of pages.
    (The command "gwd" has a new option "-setup_link" to add that).
  - [11 Jan 02] Fixed bug: the macros in places were not expanded in the
    places/surnames pages, in descendants and in ancestors pages.

* Setup program (gwsetup)
  - [30 Jan 02] Fixed bug: if the access path to the commands
    (conversions from and to gedcoms or source files, initialisation of
    consanguinity) contained spaces, these commands failed.
  - [21 Jan 02] In "parameters of the data base", added the ability
    to configurate other useful variables: history, images_path,
    hide_advanced_request, and so on.
  - [14 Jan 02] Big cleanup in this program: now all templates files
    are grouped together for all languages, which saves 250 files in the
    distribution! This has other advantages: 1/ easier to maintain 2/
    easier to add new languages 3/ easier to extend 4/ exactly same look
    for all languages 5/ easier to see which sentences are missing in a
    language.
  - [13 Jan 02] Proposes now both addresses localhost and 127.0.0.1.
    (sometimes just one of them work and not the other).

* Gedcom to GeneWeb (ged2gwb)
  - [16 Feb 02] Added code to get all the sources from the gedcom to
    the person's notes (code written by Ludovic Ledieu).
  - [23 Jan 02] Accept now some forms of incorrect dates which do not
    respect the gedcom standard (e.g. @#DJULIAN@ BEF 1580, which should
    be BEF @#DJULIAN@ 1580).
  - [22 Jan 02] Added a search for godparents inside the baptism entry:
    it is not gedcom standard, but some (other) genealogy software
    exported them that way.

* GeneWeb compiler (gwc) and Gedcom to GeneWeb (ged2gwb)
  - [15 Jan 02] Can fix now some cases of "sex not coherent with
    relations", e.g. when godfather and godmother are inverted.
  - [13 Jan 02] Fixed bug (ged2gwb): failed under Windows if there was
    a first name ending with a single quote (or apostrophe) (this is a
    typical example of the bug, but it can happen in other circumstances:
    the bug comes from the option -fne). The message displayed indicating
    this bug is: Uncaught exception: Invalid_argument("String.index_from")
  - [08 Jan 02] Fixed bug (ged2gwb): the divorce dates were not
    imported.

GeneWeb version 4.04
--------------------

* GeneWeb server or CGI (gwd)
  - [18 Dec 01] Fixed bug: in a read-only device (e.g. a CD-ROM), the
    relationship computing did not work if it has not been initialized
    before.
  - [17 Dec 01] In cousins displaying, added button to include the
    spouses (code written by Ludovic Ledieu).
  - [01 Dec 01] Fixed problem in case of changing a person's name, if
    the new name entered in conflict with somebody els&eacute;s (same
    "keys"). The proposed link "click here to try again" with the first
    free number could fail with some browsers (technical: the request
    could be truncated by the browser if too long). This have been changed
    into a button "create" which always works (the same change had been
    done for family forms, for the same problem, some time ago).
  - [16 Nov 01] Changed the term "switch" into "invert" (English is
    not my native language, I made a miskake when translating it).
  - [14 Nov 01] Suppressed the <nobr> tag used in several displayings,
    because it is not html standard. Its effect was to ask not to cut
    too large lines.
  - [08 Nov 01] In database forum, display 100 headers and a link to
    the previous messages, instead of all headers.
  - [20 Oct 01] In the updates forms, the order "year/month/day" in
    the dates now depends on the language. This is indicated in a new
    entry in the lexicon, "<tt>dates in form</tt>" which is
    "<tt>ddmmyy</tt>" for French (day/month/year) and "<tt>yymmdd</tt>"
    for English (year/month/day). Can be changed for the other languages.
  - [11 Oct 01] Improved persons merging (dates and places are merged
    faster).
  - [03 Oct 01] Fixed bug in displaying by places/surnames: the cutting
    of the places by "levels" worked bad.
  - [28 Sep 01] Macros now also apply in places displaying.
  - [16 Sep 01] Added variable "max_images_size" in base configuration
    files (base.gwf) to limit the size of the images which can be sent
    by the "send image" link.
  - [13 Sep 01] Fixed bug: dates added in "family" forms were not
    completely checked ("31th of September" was accepted, for example).

* Setup program (gwsetup)
  - [21 Nov 01] Fixed bug under Windows: the selection of the root
    directory (e.g. "C:\") did not work.

* GeneWeb to Gedcom (gwb2ged)
  - [06 Dec 01] Fixed bug (also in "gwu"): the option -s supposed to
    select surnames did not work: the whole database was selected.
  - [09 Nov 01] If a person has a "first name alias" containing the
    "first name", he is exported in the gedcom as the first name alias
    in the first name field, with the real first name part enclosed with
    double quotes.

* GeneWeb uncompiler (gwu)
  - [19 Dec 01] Rewritten option -ad (somebody's ancestors' descendants):
    now much faster and using much less memory.

* GeneWeb databases Transfer Program (gwtp)
  - [27 Oct 01] In the executable "ged2gwb" is installed in the
    directory corresponding to the option -etc of gwtp, the users can
    upload gedcom files to update their databases.
  - [06 Sep 01] Separated the option -tmp into -log (for the log),
    -etc (for passwd, default.gwf and lang directories) and -tmp (the
    rest). Code written by Christian Perrier.

* Documentation

  - [31 Oct 01] Added a paragraph in the FAQ about why the sources in
    gedcom are sometimes not taken into account.

GeneWeb version 4.03
--------------------

* Setup program (gwsetup)
  - [17 Jul 01] Fixed bug: files selections (with "browse" buttons)
    did not work with all browsers. In particular, it was sometimes not
    possible to select files in other directories than the one of the data
    bases. All these files selections have therefore been replaced by
    versions using hyperlinks.

* GeneWeb server or CGI (gwd)
  - [21 Aug 01] In relationlink displaying by "shortest path", now the
    vertical bar under each person is clickable: this link triggers the
    research of the next path without that connection. In the bottom of
    the page, the ">>" actually corresponds to one of these links.
  - [16 Aug 01] Fixed bug in update family form: when updating a
    family with one witness, the form for a second (possible) witness
    displayed weird things.
  - [24 Jul 01] Fixed bug in update family form: when updating a family
    whose marriage date was in French Revolution calendar, this calendar
    was not selected in the menu.
  - [15 Jul 01] Improved alphabetical order of places in the display
    by places/surnames (code by Ludovic Ledieu).
  - [13 Jul 01] Fixed bug: in update person form, when clicking on
    "insert surname alias", the display became "insert first name alias".

* Gedcom to GeneWeb (ged2gwb) and GeneWeb uncompiler (gwu)
  - [22 Aug 01] In ged2gwb, recover now some errorred situations in
    GEDCOMs which were rejected before: 1/ when a person is a spouse of a
    family but neither husband nor wife in this family (now sometimes
    recovered, but not always) 2/ when a father has female sex or a mother
    has male sex (the family gets the flag "no sexes check"). Moreover,
    now ged2gwb automatically put parents to isolated persons, so that the
    future cleanups of the database do not suppress them.
  - [17 Jul 01] Now, selecting surnames and ancestors/descendants is
    no more exclusive. It is therefore possible to select e.g. a surname
    *and* the ancestors of somebody.
  - [06 Jul 01] Fixed bug: sometimes failed when converting ansel text
    to ascii.

* Base configuration files (base.gwf)
  - [28 Jun 01] Added variable "hide_private_names". If set (i.e. if
    the value is "yes"), the names of the private persons (less than 150
    years) are not displayed: "x x" is displayed instead. To see the real
    names, one must be "wizard" or "friend".

* Documentation
  - [15 Aug 01] Added documentation (English and French) about how to
    create a CDrom with your database. Swedish version added by Lars
    Gustavsson.

GeneWeb version 4.02
--------------------

* GeneWeb server or CGI (gwd)
  - [15 Jun 01] Fixed bug in merging families: if there were a key
    conflict in one person, the button "Create" proposing to select a
    fresh key number did not work.
  - [12 Jun 01] In case of deleted families, the list of the latest
    marriages worked bad.
  - [07 Jun 01] (technical point) fixed problem: in case when the data
    base is not writable, there was no answer. Now an error message is
    displayed.
  - [02 Jun 01] Fixed bug: in family form, if surnames contained
    double quotes, they were incorrectly displayed.
  - [29 May 01] Fixed problem with option -log (traces in a log file):
    if the log file was not writable, all requests failed (instead of
    ignoring it).
  - [11 May 01] Improved database access speed in case when many updates
    have been done (and database not having been cleaned up).
  - [09 May 01] Fixed bug: system images with underscores did not work
    (may happen in cases of customization of the welcome page)
  - [09 May 01] Fixed bug: in family update form, if the comment
    contained quotes, the text was truncated.
  - [05 May 01] When creating or modifying a family, warn for children
    whose sex is undefined.
  - [01 May 01] In personal pages, related persons (godchildren, adoptive
    children, etc) are displayed in their baptism or birth order.
  - [19 Apr 01] Improved the sending of images. Should work better,
    particularly for images sent from a MacIntosh.
  - [11 Apr 01] The Gregorian and Julian calendars did not work for years
    less than 4800 BC. Fixed.

* Templates files (etc/*.txt)
  For programmers...
  - [20 Jun 01] Added template file for update family forms (updfam.txt),
    which can then be customized.
  - [28 Apr 01] Added ability to use variable "cvar_x" in perso.txt, returning
    the value of the variable x of the base configuration file.

* Setup program (gwsetup)
  - [11 Apr 01] Fixed security hole: if the file only.txt was not
    accessible or corrupted for some reason (it should not but...), the
    gwsetup service became potentially accessible from any outside address
    (but only if people could guess the gwsetup service address). It is
    modified: now, if this file is not accessible, only requests from
    127.0.0.1 (local machine) are accepted.

* GeneWeb databases Transfer Program (gwtp)
  - [28 Apr 01] Added option -tmout to specify the time after which
    unused logins expire (default is 900s = 15mn).

GeneWeb version 4.01
--------------------

* Installation
  - [18 Mar 01] Fixed bug in Linux rpm package: the 'restart' of
    gwd did not work; it worked only by using 'stop' and 'start'.

* Languages
  - [05 Apr 01] Renamed some languages codes to be in conformance with
    the standard (http://www.oasis-open.org/cover/iso639a.html):
      * Catalan: ct replaced by ca
      * Chinese: cn replaced by zh
      * Danish: dk replaced by da
      * Swedish: se replaced by sv
    But old codes are still working, thanks to an alias language file.
    The code of the new language, Brazilian Portuguese, is pt-br.
  - [14 Mar 01] Added Brazilian Portuguese (Paulo Francisco Sedrez).

* GeneWeb server or CGI (gwd)
  - [03 Apr 01] In merge page, proposes the list of all persons having the
    same first name and same surname (and different number).
  - [30 Mar 01] In ancestors page, in long display mode, added the ability
    to have only the selected generation.
  - [25 Mar 01] Improved the displaying of phrases like "xxx is a
    grandchild of a nth cousin of yyy" in some languages (Swedish,
    Danish, French). Indeed in Swedish and Danish, the word "grandchild"
    is different according to the intermediate person (the child)'s sex.
    And in French the word "nth cousin" is different if it is a man or a
    woman.
  - [18 Mar 01] Fixed bug: the database forum did not work under Windows.
  - [18 Mar 01] Fixed bug: in case of automatic merge, the source field
    of the second person or family was lost.
  - [18 Mar 01] Improved displaying of sources in personal pages: the
    identical sources are grouped together in the same line.
  - [17 Mar 01] Fixed problem of displaying of history of updates: it
    was sometimes very very slow.
  - [15 Mar 01] Fixed bug: when merging two men (the problem did not
    happen for women), the witnesses of marriage of the second man were
    incompletely reported to the first one (they are indicated as witness
    in the first man page, but not in their own personal page in the
    "relation" section).
  - [15 Mar 01] The displaying of "John Foo of Bar, duke of Bar" ("Foo of
    Bar" being his complete surname) is now displayed "John Foo, duke of Bar"
    (was displayed like that before only for the case "John of Bar, duke of
    Bar").
  - [14 Mar 01] Added option "-blang": if no language is specified in
    the request (i.e. explicitly selected by a flag, for example), choose
    preferably the user preferred language (the one of his browser) rather
    than the default database language.
  - [13 Mar 01] Fixed problem in displaying "anniversaries month"
    in Estonian: the month appeared with all its declinations.

* Gedcom to GeneWeb (ged2gwb)
  - [07 Apr 01] Improved option -uin to move more untreated GEDCOM
    tags in the notes (code added by Ludovic Ledieu).
  - [23 Mar 01] Added option -udi x-y (Undefined Death Interval): the
    persons whose death part is undefined:
    - if before x years, are considered as alive
    - if after y years are considered as death
    - between x and y, their death value is "don't know if death"
    Default x is 80, y is 120.

* GeneWeb uncompiler (gwu) and GeneWeb to Gedcom (gwb2ged)
  - [04 Apr 01] Fixed bug: the option -d to select descendants
    sometimes forgot people, typically when there was a couple whose both
    were descendant.

* Lexicon (lang/lexicon.txt) and Welcome page (lang/start.txt)
  - [05 Apr 01] Fixed several Dutch phrases in lexicon (Herman Theys)
  - [26 Mar 01] (technical point) Grouped together all lang/*/start.txt in
    one only file lang/start.txt, easier to manipulate (at least for me!)
  - [14 Mar 01] Changed the French translation of "nth cousin":
    indeed, in French, the "nth cousin" is translated, literally, by
    "cousin of the pth degree" where "p" is "n+1": e.g. a "4th cousin" is
    "a cousin of the 5th degree". Perhaps the same thing has to be done
    in other languages...
  - [14 Mar 01] Changed the "*nth (cousin)*" entry to directly
    represent what has to be used to translate the "nth". Previously, it
    was "indirect", looking for another entry in the lexicon, which was
    complicated to understand, for the GeneWeb translators.

* Templates files (etc/*.txt)
  For programmers...
  - [17 Mar 01] File perso.txt: remplaced variables %length and %count
    by %nb_families, %family_cnt, %nb_children, %child_cnt.

GeneWeb version 4.00
--------------------

The new version number (4.00) is in honour of:
   1/ the new installer for Windows
   2/ the new port to MacOS X.

* Installation
  - [04 Mar 01] Added version for MacOS X.
  - [03 Mar 01] Changed Linux rpm package installation; it uses now
    another directory for databases (/home/geneweb/bases). Not removed
    when uninstallation, it can be used for the future GeneWeb versions,
    without requiring it to be moved.
  - [23 Fev 01] Windows version: added an "installer" (therefore
    an installation normally easier). The databases are put in
    a directory different from the program, therefore not deleted when
    the program is uninstalled, and can be directly usable if another
    version is installed.

* Languages
  - [27 Feb 01] Added Polish (Sebastian Tuszynski)
  - [11 Feb 01] Added Catalan (Jaume Ramisa Elias)

* GeneWeb server or CGI (gwd)
  - [08 Mar 01] Added macro %i usable in person notes: it is replaced by
    firstname.num.surname (from the person key, which is used for his
    default image).
  - [28 Feb 01] In surname displaying, if several surnames match,
    everybody is displayed with his/her surname. Previously, the surname
    of the people having the first surname of the list was not displayed.
  - [24 Feb 01] Fixed big bug in Windows version: if the GeneWeb
    directory was installed in a directory which contained one or several
    spaces (e.g. C:/Program Files), and if the server "gwd" was used
    in a shortcut or in a batch file, it did not work! (this bug was due
    to a problem in a library for Windows in my favorite programming
    language).
  - [16 Feb 01] Fixed problem: when displaying a surname, if there were
    several answers, the link for displaying the first names by alphabetical
    order showed only the first surname.
  - [16 Feb 01] Fixed bug: when displaying the tree of all persons
    having the same nobility title, if there is no relationship links
    between them, the request failed.
  - [15 Feb 01] In forum, propose now "previous message" and "next message",
    instead of just "next message".
  - [11 Feb 01] Fixed a (small) bug: in the ancestors page, if the maximum
    number of generations was the authorized limit plus one, the message
    "maximum # generations" did not appear.
  - [10 Feb 01] In family update form, added button "no sexes check"
    allowing 1/ to create gay marriages 2/ to fix parents sex inversion
    without having to delete the marriage.

* Templates files (etc/*.txt)
  For programmers...
  - [02 Mar 01] For the perso.txt template file, added the variables
    %length; (family size in a %foreach;family;) and %count; (child
    position in a %foreach;child;) and ability of expressions (e.g.
    %if;(count = length) tests if the current child is the last of
    the family).
  - [18 Feb 01] Added a template file for update person form (updind.txt),
    which is now user-configurable.
  - [10 Feb 01] For the perso.txt template file, added the variables
    %father_age_at_birth; and %mother_age_at_birth;

* Gedcom to GeneWeb (ged2gwb)
  - [08 Mar 01] Recognizes now the "MACINTOSH" charset. It is not
    standard, but there are GEDCOMs with this encoding, sometimes.
  - [03 Mar 01] In case of program failure, the message is displayed
    in standard output or in the log file. It is therefore visible
    in the "traces of the last command" of gwsetup.

* Lexicon (lang/lexicon.txt) and Welcome pages (lang/*/start.txt)
  - [07 Mar 01] The "advanced request" which works too bad, is no more
    proposed in welcome pages. To have it again, you have to set the
    variable "hide_advanced_request" to "no" in the base configuration
    file.
  - [01 Mar 01] For translators: in "person/persons" phrase, it is now
    possible to add a third field to say how to translate "persons" when
    it is after a number (e.g. 50 persons). Example with Estonian.
  - [01 Mar 01] Added entry "on (weekday day month year)" for the
    anniversary page sentence: "today, weekday day month year, etc".
    Necessary at least for Finnish and Estonian.
  - [19 Feb 01] Updated several lexicon entries in Estonian (Hanno
    Kuus)
  - [16 Feb 01] In all welcome pages, suppressed the text "or surname" in
    the first choice of the first case. But it goes on searching up by
    surname, if no complete name is found.

* Base configuration files (base.gwf)
  - [01 Mar 00] The variable "always_surname" now applies also to pages
    displaying surnames by branch (no more only to descendants pages).

* Setup program (gwsetup)
  - [24 Feb 01] Fixed big bug: when creating a database, a page
    displays that the database has been created. Ok. But if this page is
    requested again later by the browser and if it is no more in the
    browser cache, the action is made again overwriting the possible user
    changes.
  - [23 Feb 01] Added option -gd (gwsetup directory) to set a different
    directory for the gwsetup files. It allows to launch gwsetup in another
    directory, therefore to separate the databases from the GeneWeb files.
  - [20 Feb 01] Added option -lang: if provided in parameter, the lang
    name is not asked the user. Changed all "http://localhost:" into
    "http://127.0.0.1:" which always work on Windows and in all OSes.
    Changed all "file://localhost/..." into just "file://..."

GeneWeb version 3.11
--------------------

* Languages
  - [04 Feb 01] Added more declinations for dates (to make Estonian work
    better)
  - [31 Jan 01] Added Estonian (Hanno Kuus)

* GeneWeb server or CGI (gwd)
  - [01 Feb 01] In descendants display, added the occupation.
  - [30 Jan 01] Added a way to be able to print trees which are too
    wide for printers. In tree displaying, a link is proposed in the upper
    right corner of the page. When clicking on it, a page is proposed for
    a parametrizable display of the tree by slices.
  - [29 Jan 01] For GeneWeb sites accommodating many databases: to
    avoid the creation of too many files in the same directories, added
    the ability to put them in sub-sub-directories. A database file can
    be installed in a sub-directory of its first character,
    sub-sub-directory of its second character. For example, a file
    associated with the database foo can be in the directory f/o/. This
    is not required, but optional, and is therefore backward
    compatible. This applies to:
      * the database directory: f/o/foo.gwb
      * the database configuration file: f/o/foo.gwf
      * the associated images directory: images/f/o/foo
      * the associated extra images directory: src/images/f/o/foo
      * the associated source texts directory: src/f/o/foo/*.txt
      * the header: lang/f/o/foo.hed or lang/xx/f/o/foo.hed
      * the trailer: lang/f/o/foo.trl or lang/xx/f/o/foo.trl
      * the personal page template: etc/f/o/foo/perso.txt
  - [26 Jan 01] Under Windows, added option "-noproc" asking not to run a
    new process at each request. This option was added because some users
    under Windows reported that sometimes, the service gwd blocks after some
    requests and need to be stopped and restarted. This option may resolve
    this problem (not sure).
  - [25 Jan 01] When searching somebody by a name, if there are several
    possible answers, also display now the first names aliases (if there
    are some).
  - [23 Jan 01] Fixed bug: when changing somebody's name, in some cases
    there were no check that the key already existed, resulting of a
    double defined persons when cleaning the database.
  - [14 Jan 01] Complicated trees (ancestors, descendants, relationships) now
    work with browsers without tables (like Lynx).
  - [13 Jan 01] Fixed bug: when merging families, the marriage witnesses
    disappeared.
  - [10 Jan 01] In relationship computing, changed translation of the
    phrase "of a cousin". Indeed, in the context, it should display "of a
    cousin(male) or a cousin(female)". In English there is just one word,
    "cousin" for male cousins and female cousins, but not in many other
    languages (German, French, Spanish...). Now, the translation is
    correct for these languages.
  - [28 Dec 00] (detail) In short dates, for the case "don't know if
    dead", now print just "year" instead of "*year". Changed all FAQ about
    this convention of short dates.
  - [19 Dec 00] In update page, changed "add family" into "add
    marriage" because, despite the warning at end of this page, many
    users are mistaken by thinking it was "add a child in a family".

* Template (etc/perso.txt)
  - [02 Feb 01] Added boolean value "has_siblings".
  - [20 Jan 01] In personal page template file (etc/perso.txt), the macro
    "%nobility_titles;" has been decomposed into "%foreach;nobility_title;"
    and "%nobility_title;", allowing to display the nobility titles
    differently (e.g. in a list <ul>..</ul>).
  - [27 Dec 00] The value "%witness;" refers now to the witness person
    himself (instead of being the text with link and dates). This allows to
    customize now the display of witnesses, e.g. by adding their professions,
    or their parents, etc.

* Setup program (gwsetup)
  - [22 Jan 01] Added the merging of databases. Updated the documentation
    to remove the comments telling that this operation cannot be done under
    gwsetup.

* Gedcom to GeneWeb (ged2gwb)
  - [23 Jan 01] Added a hack to turn around a bug in the GEDCOMs
    coming from Genealogos (fields inverted in certain lines) which
    created empty databases.

* GeneWeb to Gedcom (gwb2ged)
  - [04 Feb 00] Added option "-aws" (Ancestors With Siblings), the same
    option than for the command "gwu", extracting somebody's ancestors,
    together with their siblings, siblings' spouses and siblings' spouses'
    parents.
  - [18 Jan 01] Fixed problem for names with declinations: they were
    exported with all their declinations; now just the 'nominative'
    form is exported.

* Geneweb compiler (gwc)
  - [07 Jan 01] Put back the option "-sh #" (removed in version 3.08):
    it seems that some users are be still interested in this option, even
    with the new form "-sep".

* Bases configuration files (base.gwf)
  - [25 Jan 01] Added variable "private_years" to specify the number
    of years for the visibility of personal information in normal access
    (i.e. neither "friend" nor "wizard"). Default = 150.
  - [30 Dec 00] In example file a.gwf, fixed comment about customized
    variables: for variable defined as var_foo, the usage in the text
    is %vfoo; (not %foo;).
  - [29 Dec 00] Added variable "always_surname" telling to always print
    the children surnames in descendant display, even if same than the
    father's (default = no).

* Header and trailer files (lang/base.hed lang/base.trl)
  - [26 Jan 01] Added two macros usable in header or trailer files: %p
    which is replaced by the prefix of the current URL (the whole address
    up to the question mark) and %s by its suffix (after the question
    mark). In personal pages, this suffix is independent from the index:
    can therefore be used to specify a bookmarkable address.

* Lexicon (lang/lexicon.txt)
  - [26 Jan 01] Changed entry name "(french month)" into "(french revolution
    month)" (which is more exact).
  - [30 Dec 00] Fixed German translations (Frank Komarek + Falko Trojahn)
  - [29 Dec 00] Fixed some Spanish translations (Frank Komarek)

* Documentation
  - [17 Jan 01] Added French translation of "The GeneWeb source file format"
    (Melchior de Contades)

GeneWeb version 3.10
--------------------

* GeneWeb server or CGI (gwd)
  - [14 Dec 00] Added a system of general macros for "sources" and
    "notes". You can define customized variables in the configuration
    file (base.gwf): their values will be replaced in the "sources" and
    in the "notes". The syntax in configuration file is "var_ident=value"
    and in the sources and notes: "%vident;".
  - [03 Dec 00] Fixed bug in Hebrew calendar computation (example: Hebrew
    day was good for Gregorian date 2001-11-30 but incorrect for the following
    day 2001-12-01).
  - [28 Nov 00] Fixed bug: it was possible to create a loop by merging
    somebody with one of his/her ancestor.
  - [25 Nov 00] Small improvements: in update page, added "back" link,
    in "family deleted" page, added link to return to the person.
  - [24 Nov 00] Fixed bug: in automatic merge steps, the database was
    not locked, risking to corrupt the database if two persons were making
    changes exactly at the same time.
  - [18 Nov 00] Fixed bug: while updating a person or a family, in
    case of keys (first name/surname/number) conflicts, if there where
    empty spaces (for example the ones of persons to be removed from the
    list), the button "create" supposed to try again with the first free
    number did not work.
  - [16 Nov 00] Fixed bug: in languages with declinations (e.g. German)
    some declinations structures sometimes incorrectly remained in the
    displayed text (e.g. "xx ist ein:d:+em Cousin")
  - [11 Nov 00] When updating, display now a warning in case when the
    person has a sex inconsistent with his/her "relation" (e.g. woman
    being godfather or man being godmother). Can now change a wrong or
    undefined sex according to these "relations". The same changes have
    been done in gwc (GeneWeb uncompiler) and in ged2gwb (GEDCOM to
    GeneWeb). Code written by Ludovic Ledieu.
  - [10 Nov 00] Fixed bug: when merging two persons, if the second one was
    a witness of a marriage, the "witness" link dispeared.
  - [09 Nov 00] Fixed bug: under Windows, the history of updates did not
    work.
  - [08 Nov 00] Added the ability to have associated HTML pages and
    images. The request "base?m=SRC;v=xxx" displays the file
    "src/base/xxx.txt" (interpreting the macros if any). The request
    "base?m=IM;s=yyy" displays the image file "src/base/images/yyy" or
    "src/images/yyy". Code written by Ludovic Ledieu.
  - [08 Nov 00] Fixed bug: when giving 0 as Sosa number, it did not
    answer (infinite loop in gwd).

* Gedcom to GeneWeb (ged2gwb)
  - [04 Dec 00] Now, the option -fne works (i.e. extracts the main first name)
    even when the first character is a space, allowing to treat Gedcoms with
    for example, just a star after the main first name.

* GeneWeb uncompiler (gwu)
  - [26 Nov 00] Added option "-aws" (Ancestors With Siblings), extracting
    somebody's ancestors, together with their siblings, siblings' spouses
    and siblings' spouses' parents.
  - [16 Nov 00] Fixed bug: in some circumstances, relations could be
    printed several times, resulting of several definitions and therefore
    errors when using gwc.
  - [15 Nov 00] Filter the non printable characters if any: now converted
    into spaces.

* Consanguinity computing (consang)
  - [15 Nov 00] Improved the program: now 30% faster.

* Lexicon (lang/lexicon.txt) and welcome pages (lang/*/start.txt)
  - [27 Nov 00] Updated Czech welcome page and lexicon (Petr Slansky)
  - [13 Nov 00] Deleted entry "of": using only "%1 of %2" now. Some
    consequences in displaying (depending on language).

* GeneWeb databases Transfer Program (gwtp)
  - [14 Dec 00] Added a system to display pages on other languages than
    English. Added French version.
  - [07 Nov 00] Added "body_prop" (text added inside the tag "body" in
    generated pages, what allows to change the background, for example)
    among configurable variables (conf.txt).

* Installation under Linux rpm
  - [07 Nov 00] Put logs for gwsetup and gwd on /var/log.

* Documentation
  - [12 Dec 00] In the FAQ, in the entry "It does not work at all
    under Windows", added a paragraph to tell to try by replacing
    "localhost" by "127.0.0.1".
  - [27 Nov 00] Added an entry in the FAQ about the spelling correction
    and its possible strange results.

GeneWeb version 3.09
--------------------

* GeneWeb server or CGI (gwd)
  - [05 Nov 00] In case of loop in database, which stops all relationship
    computations, the error message now displays one person who is his/her
    own ancestor, allowing the wizard to fix the error.
  - [04 Nov 00] Changed forum displaying. The main page now displays only
    the headers.
  - [04 Nov 00] Fixed bug: when merging two persons, the possible notes
    of the second person could disappear.
  - [03 Nov 00] In tree display, when "images" is selected,
    also display spouses' images.
  - [02 Nov 00] Added "subject" in forum.
  - [02 Nov 00] Now display French republican years in roman digits.
  - [01 Nov 00] In nobility title display, added a link to display the
    tree of their relationship links. The tree contains only six persons
    at the same time (and a link for the next ones).
  - [28 Oct 00] Added a trace of the last "wizard" accesses (in the
    file cnt/base_w.txt). The idea is to know if some "wizards" are no
    more using their connections. Applies only to wizards defined in the
    file of the variable "wizard_passwd_file" of the file base.gwf.
  - [26 Oct 00] In forum, added "<table>..</table>" around messages
    to prevent unterminated tags to perturb the other messages.
  - [24 Oct 00] In family updating, when there is a name conflict while
    creating a person, now proposes to try again with the first free number
    Lightly changed the interface for the same situation in person updating
    (code written by Ludovic Ledieu).
  - [20 Oct 00] In family updating, added a check that (created) persons
    are born before their death: this check was missing.
  - [11 Oct 00] Important improvement: added a system of template
    files for the personal pages. It is therefore possible to change the
    displaying of the personal pages, by editing the template. It is also
    possible, for a site accommodating several databases, to have a
    personal template file specific to each database.

* Lexicon (lang/lexicon.txt) and welcome pages (lang/*/start.txt)
  - [06 Nov 00] Changed "anniversaries of death" into "anniversaries
    of dead people", since it's about their deaths but also their births.
  - [23 Oct 00] Updated Hebrew version (Jonathan B. Marder)

* GeneWeb compiler (gwc)
  - [03 Oct 00] Fixed bug: there were an inconsistency between "gwc"
    and the inline updating, for persons "keys": the inline updating
    considered spaces in names as significant but not "gwc". Result:
    when cleaning up a database (gwu + gwc) or when importing a data
    base from an old version of GeneWeb, it could cause names conflict
    errors (for example if both "Anne.0 Le Blanc" and "Anne.0 Leblanc"
    were defined).

* Gedcom to GeneWeb (ged2gwb)
  - [17 Oct 00] Fixed bug: problem of accessing persons with the same
    names when they contained declinations (Czech names, for example).

* GeneWeb uncompiler (gwu)
  - [04 Nov 00] Added option "-ad" to select all ancestors of somebody
    and all descendants of his/her ancestors (code written by Ludovic
    Ledieu).

* GeneWeb uncompiler (gwu) and GeneWeb to Gedcom (gwb2ged)
  - [28 Oct 00] Added option "-c <num>" not to export people born since
    less than <num> years nor their descendants (code written by Ludovic
    Ledieu).

* GeneWeb databases Transfer Program (gwtp)
  - [29 Oct 00] Fixed bug: if one tried to send a database several
    times at the same time (by several requests), it could create a
    corrupted database or it could make the program fail.
  - [06 Oct 00] Added ability to put a trailer text.

* Setup program (gwsetup)
  - [19 Oct 00] Updated Swedish version (Lars Gustavsson)

* Documentation
  - [19 Oct 00] Updated Swedish documentation (Lars Gustavsson)

GeneWeb version 3.08
--------------------

* Setup program (gwsetup)
  - [21 Sep 00] Fixed bug: in recovery from an old version, if the
    destination database already existed (created e.g. by a previous
    attempt), it could not overwrite the database, even it pretended
    it was going to do it. Same problem (fixed also) for the creation
    of a database from a GeneWeb source file.

* GeneWeb Service/CGI (gwd)
  - [25 Sep 00] When wizard or friend access failure, now display the
    page without the privileged access (instead of just saying "access
    failure").
  - [21 Sep 00] When modifying a person, forbid now to let his/her
    first name or surname as just "?", because it can cause problems
    of linking these persons after a database cleanup.
  - [18 Sep 00] In family updating, when creating an unknown person
    (i.e. having "?" as firstname or surname), does not set the "source"
    field any more for this person.
  - [18 Sep 00] Fixed bugs: 1/ while merging persons, automatic merging
    sometimes used to loose the death date 2/ while merging families
    the comment of the 2nd family used to be ignored.
  - [15 Sep 00] In ascendants long display, added notes for siblings if
    any (they were missing).
  - [14 Sep 00] In update page, if the person's sex is unknown, the
    selection "add family" proposes now two case according to the sex.
  - [13 Sep 00] Fixed bug: problem of age at death in descendants page,
    the same bug than for personal pages fixed 16 Aug (version 3.07).
  - [05 Sep 00] Fixed bug: in ancestors surnames list, under Lynx
    (browser for alphanumeric terminals), sometimes displayed "incorrect
    request" when clicking on certain surnames.
  - [04 Sep 00] Fixed bug: in descendants with encoding, for children
    married several times, could sometimes display the father's name
    instead of a repetition of the child's name.
  - [01 Sep 00] Fixed short dates: "between 1935 and 1938" is displayed
    now "1935/1938" instead of "ca 1935/1938".
  - [30 Aug 00] Fixed bug: sometimes accepted two persons with the same
    key. E.g.: after having defined "Charles de Gaulle" and "Charles
    Degaulle", when changing the second person' s surname into "de Gaulle",
    did not display a name conflict error.
  - [28 Aug 00] Added option "-wjf" (= wizard just friend) to permanently
    prevent all wizards in all databases to make changes.
  - [26 Aug 00] In descendants page, added male line and female line.
  - [25 Aug 00] In history, added the ability to see the changes only
    by a given wizard.
  - [24 Aug 00] Fixed bug: when entering Web addresses (http://...)
    in notes, it generates enclosing HTML code to make links, but
    sometimes it did it incorrectly. For example the image insertion
    <img src=...>? did not work because the program changed it into
    <img src=<a href=http://...>>

* Gedcom to GeneWeb (ged2gwb) and GeneWeb to Gedcom (gwb2ged)
  - [31 Aug 00] All surnames aliases (instead of only the first one) are
    now saved and restored.

* Gedcom to GeneWeb (ged2gwb)
  - [02 Oct 00] Fixed bug: did not treat begin or end dates in titles
    when defined as texts.
  - [28 Sep 00] Strip now possible tabulations found in the GEDCOM.
  - [26 Aug 00] If -epn (which is default) and -lf, tries now to lowercase
    the public names.

* GeneWeb to Gedcom (gwb2ged)
  - [06 Sep 00] Fixed bug: newlines in notes were incorrectly saved,
    resulting that when restoring the database (ged2gwb), the lines
    were catenated without any spaces.

* GeneWeb to Gedcom (gwb2ged) and GeneWeb uncompiler (gwu)
  - [02 Oct 00] Fixed problem: when selecting somebody's ancestors, links to
    relations (godparents, for example) were included, even if these relation
    were not selected.
  - [29 Aug 00] Now, when option "-d" (descendants of) is applied, the
    spouses' parents are included, except if the option "-nsp" is given.

* Geneweb compiler (gwc)
  - [25 Sep 00] Replaced option "-sh #" by "-sep": the file following
    the "-sep" option is treated as separated from the rest, i.e. the numbers
    in persons keys are automatically shifted if in conflict with the persons
    of the previous files. No more need to find a "shift" number which avoids
    the conflicts. Simplifies the databases merging.
  - [27 Aug 00] Fixed bug: date e.g. "between 1300 and 1350 Julian" where
    printed by gwu as 1300..1350J but gwc expected 1300J..1350 and resulted
    in a syntax error.

* GeneWeb databases Transfer Program (gwtp)
  - [08 Sep 00] Added small documentation (a README file) for GeneWeb
    Web site administrators.

* Base configuration files (base.gwf)
  - [29 Sep 00] The change, (version 3.06, 17 Jun 00) about can_send_image
    supposed to be yes by default, did not work: fixed.
  - [20 Sep 00] Deleted the change version 3.07 (on date: 28 Jul 00) about
    the variable body_prop. Return to the previous behavior: defined as
    empty or not defined => the default GeneWeb background is used. This
    change was necessary 1/ by consistency with other variables 2/ to
    make gwtp work correctly.

* Documentation:
  - [25..27 Sep 00] Changed in the chapters "merge.htm" and "divide.htm" the
    explanations about the separation of input files to avoid conflicts, using
    now the new option "-sep" of "gwc" instead of "-shift" (see change in gwc
    above, 25 Sep 00).
  - [09..25 Sep 00] Updated German version (Falko Trojahn).
  - [24 Sep 00] Added a chapter (gwformat.htm) about the GeneWeb source
    file format (files ending with .gw). Written by Yann Corno. English
    version only.
  - [20 Sep 00] Added another page (gwsetup.htm) to explain how to use
    gwsetup. Added two paragraphs in a FAQ, in the beginning of the section
    "it does not work at all under windows", explaining not to delete the
    gwsetup window!
  - [07 Sep 00] In the directions for use, the entry "How to start with
    GeneWeb" now points to a page which explains that you can start with
    the program gwsetup instead of typing interactive commands, which seemed
    not to be clear. Changed diruse.htm (link to "start"), added initial.htm,
    added small paragraph in start.htm. Added also a paragraph in
    recover.htm, merge.htm and maint.htm.
  - [03 Sep 00] In FAQ, changed the text about the question of missing
    relationship links.
  - Added entries in the FAQ about:
    * [27 Sep 00] the message "probable loop in the database",
    * [08 Sep 00] the research by place/surname, where only one person
      by surname is displayed,
    * [03 Sep 00] the fact that sometimes, under Windows, it does not
      work at all,
    * [01 Sep 00] the fact that information in forms sometimes disappear,
    * [01 Sep 00] adding more information in family forms,
    * [31 Aug 00] short dates displaying conventions,
    * [31 Aug 00] repetition of Sosa numbers for ancestors lists,
    * [29 Aug 00] advanced request,
    * [21 Aug 00] people having "?" (question mark) as first name and/or
      surname.

GeneWeb version 3.07
--------------------

* New feature
  - [18 Aug 00] Added a program "gwtp" (CGI) to upload and download GeneWeb
    databases in a site which accommodate some (undocumented program for the
    moment).

* Distribution
  - [18 Aug 00] Create files named README.htm and LISEZMOI.htm instead
    of README.txt and LISEZMOI.txt.

* GeneWeb Service/CGI (gwd)
  - [16 Aug 00] In personal pages, does not display the age at death
    if less than one year and undefined month/day (it displayed "age at
    death: birth"!)
  - [14 Aug 00] In personal pages, sources are now printed, even for
    non friends, non wizards.
  - [11 Aug 00] In first names by alphabetic order for a given surname, now
    always specify the parents' names.
  - [09 Aug 00] Fixed a problem of missing space after "married to" in
    descendants page (did not happen with all browsers).
  - [30 Jul 00] Added an option "-conn_tmout" (available only under
    Unix) to specify a connection timeout for one request. If the request
    has not terminated after this time, it is killed. Default is 120s.
  - [30 Jul 00] Contribution from Ludovic Ledieu: changed displaying
    of ancestors trees: 1/ clicks on persons fall on their personal pages
    (no more for navigation) 2/ vertical bars are clickable to navigate 3/
    no more bars for missing ancestors.
  - [28 Jul 00] Fixed problem in images displaying in personal pages
    and in trees. Sometimes the image was "broken", its URL being
    incorrect. Details:
    * This happened in case of local image (field "image" filled in "person"
      form), and when the type was not among the recognized types
      (i.e. presently "gif", "jpeg", "png"): in these conditions, the URL
      for the image was incorrect.
    * The fix is not completely satisfactory: this kind of image is now no
      more displayed at all. Indeed, "gwd" need to know its type to answer
      the browser request (the HTTP answer must contain the image type).
    * A solution if there are images with other types than the ones that
      "gwd" recognizes, is to use the variable "images_path" in the data
      base configuration file (base.gwf). See the changes version 3.05 or
      the distributed example file "gw/etc/a.gwf".
  - [26 Jul 00] Added small icon in personal page to indicate sex
    (Louis Granboulan's idea)
  - [19 Jul 00] Fixed bug in places/surnames displaying: some identical
    places and surnames could be displayed several times.

* Gedcom to GeneWeb (ged2gwb)
  - [09 Aug 00] Added a consistency check: in some gedcoms (from bad
    genealogy software), it happens that a person can be noticed as
    "spouse" (FAMS) of a family without being however neither husband
    (HUSB) nor wife (WIFE) in that family. In the GeneWeb database, the
    symptom was that the pages concerning this "spouse" (particularly
    his/her personal page) stopped in the middle. Now the converter
    displays an error message and fixes this inconsistency in the created
    database.
  - [28 Jul 00] Fixed bug: when a person was married several times,
    the order of families were sometimes incorrect. Actually, the order
    wrongly followed the order where the families appeared in the
    gedcom, not the order indicated in the individual record.
  - [26 Jul 00] Added a lock to the database before writing it (to avoid
    multiple accesses which risk to damage it).

* Base configuration files (base.gwf)
  - [28 Jul 00] Changed the behavior of the variable "body_prop" making
    the difference between 1/ not defined and 2/ defined as an empty string.
    In the first case, the default is assumed (i.e. GeneWeb's default
    background), in the second case, nothing is added in the <body>
    tag. This implies changes in programs "gwd" and "gwsetup".

* Lexicon (lang/lexicon.txt) and welcome pages (lang/*/start.txt)
  - [21 Jul 00] In lexicon: added the terms "Sosa"; changed "list" into
    "list/list (ancestors)" (specially for better translation in Swedish)
  - [18 Jul 00] Fixed Esperanto version (Thomas Ailleret).

* Documentation:
  - [16 Aug 00] Added an entry in the FAQ about the displaying of ages
    of persons of more than 80 years old.
  - [21 Jul 00] Documentation updates in Swedish (Lars Gustavsson)

GeneWeb version 3.06
--------------------

* Languages
  - [20 Jun 00] Added Latvian (Janeks Kamerovskis).

* Setup program (gwsetup)
  - [20 Jun 00] Added Latvian version (Janeks Kamerovskis).

* GeneWeb Service/CGI (gwd)
  - [04 Jul 00] Put all statistics in a different page (accessible only
    to "wizards" and "friends").
  - [04 Jul 00] Added the computation of the persons who lived the longest.
  - [27 Jun 00] When typing a name holding a number, searches also with
    its equivalent in Roman digits (e.g. it is possible to type "Louis 15"
    to find "Louis XV").
  - [26 Jun 00] Fixed bug: the images in ".png" format were not accepted.
  - [23 Jun 00] Added descendants displaying with d'Aboville's encoding.
  - [21 Jun 00] Added displaying of oldest perhaps still alive (from welcome
    page).
  - [20 Jun 00] Changed displaying of marriage witnesses in personal pages.
  - [20 Jun 00] Together with the link to the welcome page (up arrow), added
    a link to the referer page (left arrow).
  - [19 Jun 00] Changed page design of relationship computing.
  - [19 Jun 00] In latest marriages, display now only true marriages (i.e.
    not "relations" nor "engagements").
  - [18 Jun 00] Added a link in bottom of welcome pages, useful if you
    have got a browser which does not automatically update the modified
    pages (forcing you to do "reload current document"). When clicking on
    it, you browse without this problem: no more need to reload the pages,
    they are displayed with their changes if there are some.
  - [18 Jun 00] Fixed little problem: the (new) fast merges of persons did not
    appear in the history.
  - [17 Jun 00] In update family forms, added a button close to the "family
    source": when selected, the "family source" text is automatically put
    (as default value) in "family source" fields in future other family
    updates. It avoids to have to copy it each time when it is always the
    same one.
  - [16 Jun 00] Added feature: in relationship computing, when option
    "shortest path" is selected, it is displayed together with a link
    to see the next shortest path.
  - [13 Jun 00] Deleted this stupid "<meta http-equiv...>" in welcome pages
    and in other pages, because it makes some browsers generate two requests
    and we see the page blinking. Moreover, it has no sense (even if it is
    standard), since the HTTP header already contains that.

* General
  - [26 Jun 00] In programs ged2gwb (gedcom import), gwb2ged (gedcom export),
    consang (consanguinity initialization) and gwu (uncompiler), added an
    error message in case of several input files are given (these programs can
    treat only one file at a time).

* GeneWeb compiler (gwc) and uncompiler (gwu)
  - [29 Jun 00] Fixed problem: persons with "relations" (e.g. adoptive
    children) where not saved (gwu) nor restored (gwc) when isolated
    (i.e. without parents nor marriages).

* Base configuration files (base.gwf)
  - [17 Jun 00] By default now, the "can_send_image" is "yes", meaning that
    if you specify nothing, the "send image" is proposed in update pages. To
    unset it, you must now specify: can_send_image=no

* Lexicon (lang/lexicon.txt) and welcome pages (lang/*/start.txt)
  - [20 Jun 00] Added entry !language for the translation of languages names
    in all languages. Used as labels associated with the flags of welcome
    pages.
  - [14 Jun 00] Completed and fixed Portuguese version (Jose Paulo Moitinho
    de Almeida).
  - [14 Jun 00] Completed Dutch lexicon (Bernard Ceurstemont).

* Documentation
  - [26 Jun 00] In update.htm, added that images in png format are accepted,
    like "gif" and "jpeg" ones.

GeneWeb version 3.05
--------------------

* GeneWeb Service/CGI (gwd)
  - [03 Jun 00] In history, added an input field before the ">>" to be able
    to specify a number of entries to be displayed in the next page.
  - [02 Jun 00] Merge of individuals faster now: can automatically merge
    families and individuals when they are identical in both ancestors trees.
  - [23 May 00] In "divorce" section, added case "separated".
  - [18 May 00] In displaying by places/surnames, baptism places are added
    with birth places and burial with death.
  - [17 May 00] Added an "Ok" button after the password input area
    in CGI mode.
  - [14 May 00] Added case "engaged" in "family" forms.
  - [14 May 00] Added option "-images_url" to give an URL to GeneWeb
    images (flags, logo, background, up arrow). Can be useful e.g. in
    cgi mode if the associated Web server answers faster than gwd. By
    default, the GeneWeb images are sent by gwd.
  - [14 May 00] Fixed bug in update forms (person or family): in case of
    name conflict (name already used by another person), when clicking on
    the "return" button, the fields containing quotes ("), less (<) or
    greater (>) characters were truncated.
  - [12 May 00] In short dates (just year), if no death date, burial date
    is now displayed. And in pages displaying the ages at death, take now the
    baptism date if no birth date and the burial date if no death date to
    compute this age (then prefixed by "possibly")
  - [10 May 00] In personal pages, the links "ancestors" and "descendants"
    are proposed from 2 generations (instead of 3, before).
  - [06..11 May 00] Added surname list from "ancestors" page.
  - [02 May 00] [technical] In Unix version now, each request gets the
    user id and the group id of the owner of the database directory
    (base.gwb). No error if cannot change to these ids. Deleted the gwd
    options -setuid and -setgid now useless.
  - [30 Apr 00] Fixed little problem with displaying by places for the ones
    containing several (at least two) indications between parentheses.

* Gedcom to GeneWeb (ged2gwb) and GeneWeb to Gedcom (gwb2ged)
  - [25 May 00] Now save and restore the marriage witnesses (that was
    missing).

* GeneWeb to Gedcom (gwb2ged)
  - [04 Jun 00] Fixed bug: did not save the information "not married" when
    no date specified. (Note: in GeneWeb, since there is no GEDCOM standard
    for that, the information "not married" is written as "unmarried" in the
    marriage place.)

* Base configuration files (base.gwf)
  - [03 Jun 00] Added variable "propose_add_family" (default yes). If yes,
    propose to wizards a "add family" link in welcome page. If no, not
    proposed.
  - [25 May 00] Added variable "images_path" to specify a path to access
    the images defined in the "image" field (i.e *not* added by "send image").
    Applies only for images not found in the image/base directory. This
    variable, when set, could typically start with http://...
  - [08 May 00] (detail) The possible trailing spaces or control-m are
    now stripped (allowing to move a base.gwf file from Windows to
    Unix without needing to remove them).

* Counters (cnt/base.txt)
  - [28 May 00] Now, a count of "wizard", "friend" and normal accesses
    are added in this file, for statistics.

* Documentation
  - [31 May 00, 06 Jun 00] Added paragraph explaining how to install GeneWeb
    in server mode under Windows NT (Falko Trojahn). English and German
    versions by Falko Trojahn. Swedish translation by Lars Gustavsson.
    French translation by Daniel de Rauglaudre.
  - [25 May 00] Updated German documentation (Falko Trojahn).
  - [06 May 00] Updated Swedish documentation (Lars Gustavsson).
  - [04 May 00] Added one item in FAQ about a possible problem in CGI mode.

GeneWeb version 3.04
--------------------

* Languages
  - [06 Apr 00] Added Afrikaans (Louis Kruger).

* Setup program (gwsetup)
  - [09 Apr 00] Fixed some bugs in Linux rpm package causing gwsetup to
    fail and the browser to answer "no output".

* GeneWeb Service/CGI (gwd)
  - [29 Apr 00] Fixed bug in "descendants", "families with encoding": the
    marriage dates of grandchildren could sometime be erroneously the ones
    of the children.
  - [16 Apr 00] Fixed problem: the kde browser (Konqueror) seems not to handle
    the password protocol. Went around the problem by treating it as it were
    in CGI mode, where the password has to be given in a form.
  - [14 Apr 00] Fixed bug: could no more access a person by his key after
    having changed his name, in the case when the initial first name or
    surname was a question marks *and* the changed name had nevertheless
    the same signature.
    Example:
       before: first name = "John Smith"; surname = "?"
        after: first name = "John"; surname = "Smith"
    When doing this fix, there were no more way to access "John Smith" by
    his key, particularly in forms (which is rather annoying).
  - [13 Apr 00] Added nice display of language code when mouse over the
    flag (Emmanuelle Visseaux's code).
  - [11 Aor 00] Added optional displaying of images in descendants by tree
    and in relationship trees.
  - [03 Apr 00] In ancestor page, added horizontal displaying.
  - [02 Apr 00] In surname page, added ability to click on a branch number
    to display only that one.
  - [27 Mar, 05 Apr 00] Added displaying of places/surnames from welcome page.

* Gedcom to GeneWeb (ged2gwb)
  - [11 Apr 00] Fixed bug+problem of adoptive children when they are also
    recorded as normal children of their adoptive parents in the GEDCOM
    (extracted from a genealogical software having a different logic than
    GeneWeb about this subject). The "bug" made the adoptive links not
    appear, the "problem" made the parents family not appear.
  - [31 Mar 00] Do not enter any more GIVN as public name if equal to first
    name nor SURN as surname alias if equal to surname.

* GeneWeb uncompiler (gwu) and GeneWeb to gedcom (gwb2ged)
  - [04 Apr 00] Added option "-nn" not to save database notes.

* Base configuration files (base.gwf)
  - [31 Mar 00] Added variable "places_inverted" (default no) to specify that
    places are ordered more-general-less-general (e.g. "USA, New York"
    instead of "New York, USA"). Important to specify correctly this variable
    for the new displaying by places/surnames.

* Lexicon (lang/lexicon.txt)
  - [26 Apr 00] Changed "death age" into "age at death", "maybe" into
    "possibly" and "degre" into "degree".

* Documentation
  - [20 Apr 00] Changed the title of the chapter "How to install GeneWeb as a
    server" into "How to install GeneWeb as a server or CGI" (English and
    French versions).
  - [20 Apr 00] Changed the chapter "How to customize the welcome page".
    The title becomes "How to customize the welcome page and the other pages"
    A section "Customization of all the pages" has been inserted at end
    (English and French versions).
  - [20 Apr 00] Added the French version of the chapter "Keeping data
    divided inside a database".

GeneWeb version 3.03
--------------------

* Languages
  - [23 Jan 00] Added Russian (Konstantin Abakumov).

* Setup program (gwsetup)
  - [07 Feb 00] Changed some Swedish files (Lars Gustavsson).
  - [27 Jan 00; 03 Feb 00] Added a comment in the introduction text
    telling not to delete the window! (English, French, Swedish versions)

* GeneWeb Service/CGI (gwd)
  - [17 Mar 00] In CGI mode, the passwords are no more visible in the URL.
    Technical explanation: it works with a generated random login password
    with a timeout of 1800 seconds (half an hour), i.e. if you do nothing
    during half an hour, the login password is unactivated; this limit time is
    changeable by a new gwd option "-login_tmout". Note: this system does
    not use cookies.
  - [12 Mar 00] In ancestors page, added male and female lines.
  - [11 Mar 00] In personal pages, the images defined by external URL (i.e.
    accommodated in other Web sites) are now reduced as are local images.
  - [11 Mar 00] The information "relationship to" is no more transformed
    into "married to" when "non-friend" browsing (it was supposed to protect
    private life, but seems to have more drawbacks than advantages).
  - [09..10 Mar 00] In update family form, added ability to specify birth
    place, death date and death place for parents and children.
  - [08 Mar 00] Added latest marriages (accessible only by "wizards" and
    "friends")
  - [08 Mar 00] Added optional displaying of images in ancestors displaying
    by tree.
  - [05 Mar 00] In birthday anniversaries for close parents (accessible
    in "cousin" page for "friends" and "wizards"), the links give now the
    relationship trees, instead of the persons.
  - [04 Mar 00] In person and family forms, added input area to specify
    a number greater than 1 of titles and children to insert.
  - [24 Feb 00] In latest births and deaths pages, display months.
  - [02 Feb 00] In personal pages, relations are now displayed before notes.
  - [20 Jan 00] When sorting the children, use now the baptism date
    when there is no birth date.
  - [18 Jan 00] Fixed bug: when selecting no database, the default page
    asks for a database name, but in CGI mode when entering a database,
    it did not work (incorrect URL).

* Gedcom to GeneWeb (ged2gwb)
  - [19 Feb 00] Added option "-uin" (untreated in notes) asking to put
    unused Gedcom tags (of indiduals) in notes.

* Base configuration files (base.gwf)
  - [24 Feb 00] Added variable "latest_event" to give the number of latest
    events (births, deaths) displayed (default: 20).
  - [25 Jan 00] Added variable "public_if_titles": if "yes", consider persons
    having nobility titles as public ("public" means that their private data
    is displayed even if their dates is less than 150 years). Warning: the
    default of this variable is "no": it is a behavior change in GeneWeb,
    relatively to previous versions (but don't worry: with this change,
    private data is better protected).

* Lexicon (lang/lexicon.txt) and welcome pages (lang/*/start.txt)
  - [10 Mar 00] Changed some Finnish translations (Antti Alfthan)
  - [14 Feb 00] Changed the term "place" of nobility titles into "estate"
    ("domaine" in French), to avoid the confusion with the "place" of
    "birth", "death", and so on. Changed also "all the places" into
    "all the estates".
  - [01 Feb 00] Fixed some Swedish translations (Lars Gustavsson)
  - [26 Jan 00] Fixed several Portuguese translations (Jose Paulo Moitinho
    de Almeida).
  - [21 Jan 00] Changed the English displaying of dates into "day month
    year", the displaying "month day year" being specific to the United
    States and not used in other English speaking countries. American
    users are invited to change the lexicon line for (date) if they
    want an American display.

* Documentation
  - [17..25 Feb 00] Added a new chapter "Keeping data divided inside a
    database" (written by Lars Gustavsson: thanks, Lars!). Only
    English and Swedish versions for the moment.
  - [11 Feb 00] Changed some Swedish files (Lars Gustavsson).
  - [03 Feb 00] In chapter "modifications" (update.htm), section 1,
    added a footnote to explain that it is better to use western Europe
    languages encoding (iso-8859-1) for a person's "key".

GeneWeb version 3.02
--------------------

* Setup program (gwsetup)
  - [Dec 13, 99] Fixed another problem of images displaying with still
    another browser (see version 3.01).

* GeneWeb Service/CGI (gwd)
  - [Jan 12, 00] In adding or modifying family, added a specific field
    to indicate the source for (possibly) created persons.
  - [Jan 3, 00] Speeded up the displaying of anniversaries (noticeable on
    large databases).
  - [Jan 10, 00] Forbid "send image" when the person's first name or
    surname is "?" ("dead end" person).
  - [Jan 9, 00] Added birthday anniversaries for close parents (accessible
    in "cousin" page when wizard or friend).
  - [Dec 26, 99] Added the ability to add a file "foo.hed" for the base
    "foo", in lang directory: the file is inserted in the header of all
    pages (useful e.g. to add style sheets).
  - [Dec 21, 99] Changed display of relationship by shortest path.
  - [Dec 19, 99] Added option -wd to specify a (writable) directory for
    socket communication (required for Windows) and databases access
    count. Useful to use GeneWeb and databases in a CDrom.
  - [Dec 17, 99] Added <meta http-equiv...> in headers of all generated
    pages to be compatible with all browsers.
  - [Dec 16, 99] Fixed bug: the ";opt=no_index" did not work correctly
    when the URL hold special characters.
  - [Dec 15, 99] Added things to be able to translate correctly the
    noun complement ("x of y") in Finnish which sucks in the present
    version.
  - [Dec 14, 99] In relationship links with option "by marriage" does not
    display the consanguinity (0%) any more if all relations found are by
    marriage.
  - [Dec 14, 99] Fixed bug: in relationship links, with option
    "relationship by marriage", when several branches, sometimes did not
    display the persons (sometimes only the spouses, sometimes branches
    were missing).
  - [Dec 13, 99] In tree displays with several branches, add the spouse(s)
    of the top person(s).
  - [Dec 13, 99] Fixed bug: when merging two persons, the godchildren,
    possible children, foster children (and so on...) of the second
    person were not transferred to the first person (problem only
    with "children" relations, not "parents").
  - [Dec 10, 99] In tree displays with several branches, the option
    "add spouses" did not work. Fixed.

* GeneWeb compiler (gwc)
  - [Jan 15, 00] Fixed bug: did not recognize foster parents

* GeneWeb uncompiler (gwu)
  - [Jan 15, 00] Fixed small bug: used to save notes for relations even
    if no notes were defined.

* GeneWeb uncompiler (gwu) and GeneWeb to gedcom (gwb2ged)
  - [Dec 13, 99] Fixed bug: the option '-s' (extraction of a surname)
    also selected children with different surnames.

* Gedcom to GeneWeb (ged2gwb)
  - [Jan 6, 00] Added option -ds (default source) to set a default source
    to the persons having no source data.

* Lexicon (lang/lexicon.txt) and welcome pages (lang/*/start.txt)
  - [Jan 15, 00] Added "Julian day" for calendar page (and its value
    is now displayed with a thousand separator).
  - [Jan 13, 00] (detail) Changed phrase "not dead" into "living"
  - [Dec 18, 99] Fixed and completed some Norwegian phrases (Brynjulf
    Langballe)
  - [Dec 17, 99] Fixed and completed some German phrases (Marcus Zelezny)

* Base configuration files (base.gwf)
  - [Jan 10, 00] Added variable "max_cousins", by default 2000, to specify
    the maximum number of cousins who can be displayed in the cousin
    page.
  - [Dec 17, 99] Added variable "highlight_color", by default #2f6400
    (green), for the color often used in pages.

GeneWeb version 3.01
--------------------

* Languages
  - [Nov 22, 99] Added Finnish (Antti Alfthan)

* Setup program (gwsetup)
  - [Nov 29, 99] Updated French version
  - [Nov 29, 99] Updated German version (Thomas Omerzu)
  - [Nov 7, 99] Fixed problem in Windows version under Netscape: images did
    not appear...

* GeneWeb Service/CGI (gwd)
  - [Dec 2..6, 99] In relationship computing, can print the complete graph
    (all branches in one page). Proposed (when there are no too many links)
    in the list of relationships for each branch type ("click here") and
    globally in links at end of page.
  - [Nov 26, 99] Faster computation of list of all titles and all places
  - [Nov 26, 99] Fixed a problem of sometimes displaying of a message
    "document contains no data" from the browser when computing relationship.
  - [Nov 19, 99] Added ability of customization of the page displayed when
    no database is given (must make a file etc/index.txt).
  - [Nov 16, 99] Fixed bug: some old dates failed the calendars page
  - [Nov 13, 99] In calendars, display the number of days since ...
  - [Nov 10, 99] Images are now clickable to see them in their true size
  - [Nov 10, 99] Added relationship computing by shortest path (Louis
    Granboulan).
  - [Nov 10, 99] Added foster parents.
  - [Nov 10, 99] Changed structure of databases for internal optimizations.

* Lexicon (lang/lexicon.txt) and welcome pages (lang/*/start.txt)
  - [Nov 30, 99] Added French Revolution and Hebrew months in lexicon
  - [Nov 23, 99] Updated Hebrew version (Jonathan Marder)

* Base configuration files (base.gwf)
  - [Nov 15, 99] Added variables "max_anc_tree" (default = 5) and
    "max_desc_tree" (default = 4) to set the maximum number of generations
    that can be displayed by tree.
  - [Nov 13, 99] Fixed bug: when setting the variable "access_by_key" to
    "yes", links to persons holding "?" in their names did not work.

* Gedcom to GeneWeb (ged2gwb)
  - [Nov 28, 99] Deleted the too specific option -ta
  - [Nov 5, 99] Accept roman digits in years of French Republican dates.

* GeneWeb to Gedcom (gwb2ged)
  - [Nov 18, 99] Prints a space before the slash preceding the surname
    in the NAME tag.

* Documentation
  - [Nov 10, 99] Updated German version (Thomas Omerzu).

GeneWeb version 3.00
--------------------

New look for GeneWeb! Icon, default background, new structures of pages.
Thanks to Emmanuelle Visseaux.

* Languages
  - [Oct 26, 99] Added Icelandic (Ólafur Sigurgeirsson).

* Setup program (gwsetup)
  - [Oct 28, 99] Added option -p to select another port number (default: 2316).

* GeneWeb Service/CGI (gwd)
  - [Oct 24, 99] In display by surname, added a specific indication for
    the branches whose ancestor has parents with a different surname, in order
    to differentiate them with the branches whose ancestor has no parents.
  - [Oct 21, 99] Added message "or Sosa number relative to x" when displaying
    a relationship computing form if navigating with x as Sosa reference.
  - [Oct 21, 99] Limit local images height to some maximum number of pixels
    (currently 240). Not applied to distant (http://) images.
  - [Oct 21, 99] Fixed bug: there was no automatic "wizard" (resp. "friend")
    access in cgi mode when no "wizard" (resp. "friend") password was defined.
  - [Oct 20, 99] Added option -a to give a specific IP address for the
    service (must be compatible with the computer).
  - [Oct 19, 99] Added treatment of png images files.
  - [Oct 10, 99] In update form, when name conflict, added the birth and
    death date in the list of persons having the same name.
  - [Oct 8, 99] Added forum.
  - [Oct 5, 99] Fixed links problems in some pages from the DOC
    link (some problems found in the Swedish version).
  - [Oct 5, 99] Added displaying of number of persons in ascends (short
    display).
  - [Oct 4, 99] Fixed displaying bug in update history (spot displayed due
    to incorrect HTML).
  - [Oct 3, 99] Added week day in "calendars" page.

* GeneWeb compiler (gwc)
  - [Oct 26, 99] Added option -f, like in ged2gwb: by default now, if the data
    base already exists, the program exits in error. If option -f is used
    the old database is overwritten.

* GeneWeb uncompiler (gwu)
  - [Oct 24, 99] Added option -s to select all persons having a given surname
    (option usable several times). Added associated option -nsp, not to select
    the spouses' parents (what is done by default). These options has been
    added in command gwb2ged too.
  - [Oct 19, 99] Fixed bug: notes sometimes disappeared for godparents and co.
  - [Oct 10, 99] Fixed bug: dates represented as text where not extracted
    in the output file but on standard output.

* Gedcom to GeneWeb (ged2gwb)
  - [Oct 13, 99] Added option "-fne" (for "first names enclosed"): it is
    possible to give two characters telling that the usual first name parts
    is between those characters: e.g. if they are of the form:
       Bernard Jean "Philippe"
    use -fne '""' and if they are:
       Bernard Jean (Philippe)
    use -fne '()', and so on.

* GeneWeb to Gedcom (gwb2ged)
  - [Oct 24, 99] Added option -s to select all persons having a given surname
    (option usable several times). Added associated option -nsp, not to select
    the spouses' parents (what is done by default). These options has been
    added in command gwu too.
  - [Oct 5, 99] Changed the way the lines of notes are cut (by tag CONC).
    The standard GEDCOM 5.5 tells that too long lines must be cut *inside*
    words and not *between* words, to avoid starting or trailing spaces in
    CONC lines. Gwb2ged did not do that: it is fixed.
    To remain compatible with old GEDCOMS generated by GeneWeb, the ged2gwb
    program is not changed: in CONC lines, the possible starting space remains
    included in the note (what does not respect the standard, shame on
    me).

* Base configuration files (base.gwf)
  - [Oct 30, 99] Deleted variable "enclosing_tag" defined in version 2.05
    on July 18, 99. Reason: complicated the code => too many risks of operation
    bugs. Sorry for the ones who used it.
  - [Oct 29, 99] Added a variable "propose_titles" (yes by default). When
    set to "no", the search by (nobility) titles is not proposed in the
    welcome page.

* Lexicon (lang/lexicon.txt) and welcome pages (lang/*/start.txt)
  - [Oct 31, 99] [technical point] Changed the conditional macros in
    the welcome pages, now between %I and %E.
  - [Oct 26, 99] Changed several Portuguese translations (Oscar Filipe de
    Oliveira Barroso).
  - [Oct 12, 99] Fixed and completed some Norwegian phrases (Brynjulf
    Langballe).
  - [Oct 4..10, 99] Fixed and completed some Dutch phrases (Joris Esch).
  - [Oct 4, 99] Fixed some German phrases (Falko Trojahn).

* Documentation
  - [Oct 31, 99] [technical point] Updated the documentation of the macros
    of the welcome page. Chapter "customization of pages", section "macros".

GeneWeb version 2.07
--------------------

* Setup program (gwsetup)
  - [Sep 16, 99] Distribute different versions of the introduction text
    for Windows and Unix (problems of accents). (Does not concern
    the Linux distribution by rpm package.)
  - [Sep 13, 99] Added German version (Thomas Omerzu).
  - [Sep 9, 99] Added Swedish version (Lars Gustavsson).
  - [Sep 8, 99] Fixed lot of typos and errors in English version
    (thanks to Lars Gustavsson).
  - [Sep 6, 99] Fixed problem in Windows: if the user chose a
    language by writing it in uppercase letters, some phrases where
    displayed in English language between brackets (no matter which
    language was selected), indicating that the language was not found
    in the lexicon.

* GeneWeb Service/CGI (gwd)
  - [Oct 1, 99] Fixed bug: the pages from the "DOC" link were
    sometimes not correctly displayed with certain browsers (HTTP headers
    were missing).
  - [Sep 24, 99] Added history for updates (option to be set in file base.gwf).
  - [Sep 23, 99] Added witnesses for marriages.
  - [Sep 22, 99] Fixed bug: bad display of "nth cousin" in Swedish (due
    to problems with the character ":" in the translation).
  - [Sep 21, 99] Fixed bug: the "DOC" link did not work in CGI mode.
  - [Sep 21, 99] Added "CREDITS" in doc, accessible from the "DOC" link too.
  - [Sep 20, 99] Changed gif files (flags and up arrow) into jpeg files.
  - [Sep 19, 99] In "search", can find someone if only one of his first
    names is given: e.g. can find "Marie Liesse de Rohan Chabot" if searching
    "Marie de Rohan Chabot" or "Liesse de Rohan Chabot". Works partially,
    i.e. only if the classic search failed.
  - [Sep 17, 99] Can use now special characters for wizard/friend passwords
    in CGI mode (before, it worked only in service mode).
  - [Sep 16, 99] Advanced search with baptism date and place did not work:
    fixed.
  - [Sep 16, 99] Changed the order of dates in modifications forms into:
    year/month/day and these fields are now labelled.
  - [Sep 15..27, 99] Added calendars for dates (Gregorian, Julian, French
    Republic, Hebrew).
  - [Sep 11..17, 99] Now, several users and passwords can be defined for
    "wizard" and "friend" access, by specifying authorization file names in
    the "base.gwf" file.
  - [Sep 8, 99] Fixed bug: in descendant displaying, if the person has
    quotes in his name, the displaying was sometimes wrong.
  - [Sep 8, 99] In "DOC" links, in the bottom of the pages, the links
    with Email addresses did not work correctly. Fixed.

* Gedcom to GeneWeb (ged2gwb)
  - [Sep 28, 99] By default now, if a database with the same name already
    exists, does not erase it and exits in error. Added option -f to
    overwrite the old version.

* Consanguinity computing (consang)
  - [Sep 17..19, 99] Run faster when no modifications have been done (e.g. just
    after the creation of the database).

* Lexicon (lang/lexicon.txt)
  - [Sep 22, 99] Fixed some German phrases (Gerriet Backer).

* Documentation
  - [Sep 10, 99] Updated Swedish files (Lars Gustavsson).
  - [Sep 7, 99] Fixed some typos in the "pcustom.htm" files (English,
    German and Swedish versions).

GeneWeb version 2.06
--------------------

* Installation
  - [Sep 2, 99] Linux distribution will includes rpm packages.

* Setup program (setup) and GeneWeb Service (gwd)
  - [Sep 2, 99] Under Unix, find the default language in the environment
    variables LANG or LC_CTYPE.

* Setup program
  - [Aug 16, 99] Renamed this program "gwsetup".
  - [Aug 16, 99] Fixed bug: sometimes tried to display a non-existent file
    "warnings.htm".

* GeneWeb Service/CGI (gwd)
  - [Aug 19, 99] Fixed bug: the "back" button which appears after error
    in update used to forget the selected language.
  - [Aug 19, 99] Added more information (places) in descendants display
    by list.
  - [Aug 18, 99] Added a link to the documentation (close to the copyright).
  - [Aug 14..21, 99] Added a ility to put notes for the database itself (for
    a general introduction).
  - [Aug 14, 99] Fixed bug: send image in cgi mode under Windows did not
    work.
  - [Aug 13..21, 99] In notes, URLs and Email addresses are now clickable.
  - [Aug 13, 99] Added the ability to change the text of some pages:
    1/ for site address redirection (gwd new option "-redirect", see below),
    2/ for database name change (gwf file field "renamed") and
    3/ detected robot exclusion (when option -robot_xcl has been set).
  - [Aug 13, 99] Fixed bug: when merging persons, the "other relations" where
    not included.
  - [Aug 8, 99] Added option "-redirect" to say to the users that the
    GeneWeb service has been redirected to some other address.

* Gedcom to GeneWeb (ged2gwb)
  - [Aug 30, 99] Added option "-no_pit" (= no public if titles): do not
    automatically consider persons having titles as public.
  - [Aug 29, 99] Fixed bug on access with pointers (between '@' in the
    gedcom) resulting on bad errors detections.
  - [Aug 22, 99] The option "-no_efn" is now the default. Made the change
    in "setup" files too.

* Base configuration files (base.gwf)
  - [Aug 20, 99] Added new variables "max_anc_level" and "max_desc_level"
    to specify the maximum level of generations that can be displayed in
    ancestors and descendants displaying (default resp. 8 and 12 generations).
  - [Aug 18, 99] Added a new variable "auth_file" in databases configuration
    files (files ending with ".gwf") overriding the possible authorization
    file set by option "-auth" of gwd. Therefore now, each database can have
    its specific global restricted access. See the template file "a.gwf".
    Works only in server (not cgi) mode.

* Lexicon (lang/lexicon.txt)
  - [Aug 29, 99] Updated some Dutch phrases (Joris Esch).

* Documentation
  - [Sep 1, 99] Added German version (Falko Trojahn)
  - [Aug 19, 99] Added new chapter "the access restrictions to databases"
    about wizards, friends, global access restrictions, robots, black list.

GeneWeb version 2.05
--------------------

* General
  - [Aug 4, 99] In the distribution main directory, files README.txt (English)
    and LISEZMOI.txt (French), added a few lines of explanations for starting
    with GeneWeb.
  - [Jul 15, 99] Changed internal representation of strings in databases.
    Should not make any differences while browsing. However, as it is a major
    internal change in the program, problems may appear (mainly in displaying
    or in access by name, first name, surname, title...): please report if any
    problem.

* Setup program
  - [Jul 18, 99] Added in the menu "database parameters" the ability to
    display the characters in the pages 1/ in bold, 2/ in italic, 3/ in
    smaller or bigger size (using the new key 'enclosing_tag': see below
    section "base configuration files"). Bold is useful, for example, if
    a background image is used, to make the text more readable. [Spanish
    version not yet translated]
  - [Jul 15, 99] Changed GEDCOM export menu to reflect new option "-charset"
    of "gwb2ged" (see below in section "GeneWeb to Gedcom").
  - [Jul 2, 99] Fixed bug: importing GeneWeb base from old version passing
    by a GEDCOM file did not work if the current directory held spaces.
  - [Jul 2, 99] Changed names of html files to hold 8 characters maximum
    and 3 characters for the extension, to be unzippable by "pkunzip".

* GeneWeb Daemon/CGI (gwd)
  - [Aug 6, 99] Changed order of menu in "update page": separated "delete"
    from "modify".
  - [Aug 6, 99] Restored the system of robot exclusion (had been deleted
    in version 1.10) with some improvements. Option "-robot_xcl".
  - [Aug 5, 99] Added descendants displaying by tree (doesn't work with Lynx).
  - [Aug 3, 99] Added ancestors displaying (and navigating) by tree.
  - [Aug 3, 99] In relationship by branches, found a solution to
    display the vertical bars correctly aligned relative to the
    horizontal bars (works at least with Netscape, IE, Kfm).
  - [Aug 2, 99] In relationship displaying, can make the difference in
    the lexicon between father's and mother's side (used in Swedish, where
    there are different words for "uncle", "aunt", "great-uncle" and
    "great-aunt" depending on they are on father's or mother's side).
  - [Aug 1, 99] Added relationships computing by marriage.
  - [Jul 28, 99] In "cousins" pages, added link to uncles and aunts, nephews
    and nieces.
  - [Jul 26..28, 99] Added other relations: godparents, adoptive parents,
    recognizing parents, candidate parents.
  - [Jul 22, 99] In relationship branches displaying, when the spouses are
    displayed, display also the marriage date.
  - [Jul 20, 99] In the titles displaying, sort preferably the persons by
    the nth rank (e.g. "nth duke of ...") when existing.
  - [Jul 19, 99] Fixed bug in descendants by list: displaying was incorrect
    when several marriages and one of them with an unknown ("? ?") person.
  - [Jul 18, 99] When updating families, the "sources" field is propagated
    into the created persons.
  - [Jul 18, 99] Fixed small bug for the access by subparts of surnames
    (it sometimes accepted too small subparts: then the "search" could
    give weird results).
  - [Jul 17, 99] In welcome page, now search by surname when search by
    full name fails (no need to select "surname"). Idem in relationship
    computing.
  - [Jul 17, 99] Fixed bug: could not access person after having changed his
    name, in some circumstances, e.g. changing the surname "L'epine" (in
    two words) into "Lepine" (one word).
  - [Jul 16, 99] Added a "back" button in case of update error (useful
    for browsers which loose the contents of the forms when navigating).
  - [Jul 15..29, 99] In relationship computing, added a long display,
    the ability to see the spouses in branches displaying, and the ability
    to cancel GeneWeb links.
  - [Jul 15, 99] Added system of grammar declinations (required by German,
    Esperanto, Czech). Changed the lexicon to use this new system.
  - [Jul 9, 99] Added link (upper arrow) to welcome page in displayings by
    first names and surnames.
  - [Jul 9, 99] Fixed date check for possible father when interval (i.e. was
    telling "incorrect" when father died between 1250 and 1260 and son born
    in 1255).
  - [Jul 3, 99] Added "af" as possible surnames particles (this is Danish)
    possibly ignored in "search".

* Gedcom to GeneWeb (ged2gwb)
  - [Jul 5, 99] Fixed bug sometimes stopping the program (exception
    "Invalid_argument") after the detection of an error of a family whose
    parents are of bad sex (female father and male mother).
  - [Jul 2, 99] Recognizes the dates of the form "FROM..TO..".

* GeneWeb to Gedcom (gwb2ged)
  - [Jul 15, 99] Added option "-charset" whose values can be "ANSEL" or
    "ASCII": "ASCII" is the default. Deleted option "-ascii" now useless.
  - [Jul 2, 99] Generate now dates of the form "FROM..TO.." for titles.

* Base configuration files (base.gwf)
  - [Jul 18, 99] Added the key 'enclosing_tag' to enclose whole displayed
    text with one or several HTML tags. E.g. by setting it to 'strong', all
    text is displayed bold. Added comment about that in the template file
    "a.gwf".

* Lexicon (lang/lexicon.txt) and Welcome pages (lang/*/start.txt)
  - [Aug 5, 99] Updated Portuguese phrases (Yves Guignard)
  - [Aug 5..6, 99] Updated Norwegian phrases (Brynjulf Langballe)
  - [Aug 3, 99] Updated Danish phrases (Hans Albeck)
  - [Aug 3..6, 99] Updated Dutch phrases (Joris Esch)
  - [Aug 3, 99] Updated German phrases (Markus Mottl)
  - [Aug 2, 99] Updated Italian phrases (Daniel Hirschkoff)
  - [Jul 23, 99] Updated Swedish phrases (Lars Gustavsson)
  - [Jul 23, 99] Added Czech (Hanus Adler).
  - [Jul 17, 99] In welcome pages, simplified the text "it is a first
    name and surname or public name blah blah blah...".
  - [Jul 17, 99] Changed French term for "surname" ("nom" changed into
    "patronyme" more common among French genealogists).
  - [Jul 8, 99] Updated Swedish phrases (Stig Petersson)
  - [Jul 3, 99] Updated Danish phrases (Hans Albeck)

* Documentation
  - [Jul 27, 99] Updated Swedish documentation (Lars Gustavsson).
  - [Jul 23, 99] Added documentation about the languages with declinations:
    "How to make modifications in the database", section 8.

GeneWeb version 2.04
--------------------

* Setup program
  - [Jun 28, 99] Fixed bug: did not work for directories holding spaces.
  - [Jun 19, 99] Changed GEDCOM import menu to reflect new option "-charset"
    of "ged2gwb" (see below in section "Gedcom to GeneWeb").
  - [Jun 18, 99] Added a color combination in the provided palette
    whiteyellow, black, bluegreen and brown (thanks to Hans Albeck)

* GeneWeb Daemon/CGI (gwd)
  - [Jun 30, 99] Added the ability to enter a Sosa number in the welcome page
    when navigating with someone as Sosa reference number (still available from
    its "ancestors" page).
  - [Jun 30, 99] In relationship links, display common ancestors in a more
    canonical order.
  - [Jun 28, 99] Due to optimization in consanguinity computing (see below),
    the answer time of relationship computing for persons without relationship
    links is generally faster (it answers: "no relationship links" faster).
  - [Jun 26, 99] Added the ability to access persons having composed surnames
    by subparts of their surname: e.g. "Josephine Tascher de La Pagerie" can
    now be found by typing just "Josephine Tascher" or "Josephine de La
    Pagerie".
  - [Jun 25, 99] Added short (horizontal) display for surnames by
    alphabetic order + ability to cancel GeneWeb links (for creation of
    static HTML pages).
  - [Jun 22, 99] Fixed bug: send image in CGI mode did not work.
  - [Jun 19..28, 99] Added in ancestors long display the ability to select
    and unselect the displaying of siblings and the displaying of notes.
  - [Jun 19, 99] Changed presentation of ancestors displaying main menu.

* Gedcom to GeneWeb (ged2gwb)
  - [Jun 21, 99] Fixed bug: couples could sometimes be recorded as divorced,
    even if not (when there was a "1 DIV" field without DATE and PLAC in the
    gedcom file).
  - [Jun 19, 99] Can now read MSDOS accentuated characters encoding. Added
    option "-charset" which can be followed by "ANSEL", "ASCII" or "MSDOS".
    Removed options "-ansel" and "-no_ansel".
    Warning: in GEDCOM files, the charset "IBMPC" (which is not standard
    GEDCOM 5.5) is by default interpreted as "ASCII", *not* "MSDOS"; to
    override this default, the option "-charset MSDOS" will have to be used.

* Consanguinity computing (consang)
  - [Jun 28, 99] Optimized code: it is twice faster (on average) now.

* Lexicon (lang/lexicon.txt)
  - [Jun 30, 99] Translations added in Italian (Daniel Hirshkoff).
  - [Jun 18..Jul 1, 99] Translations improvements in Danish (Hans Albeck).

* Documentation
  - [Jun 30, 99] Updated Dutch documentation (Joris Esch).

GeneWeb version 2.03
--------------------

* Setup program
  - [Jun 7, 99] Added a Spanish version (Luis Castro Guzman).
  - [Jun 1, 99] The location to open is now always "http://localhost:2316/",
    independent from the selected language (no more need to end the location
    with "fr" or "en"): the page is displayed in the selected language.
  - [May 15, 99] Added deletion of ".gwo" file after then "gwc" operation.
  - [May 9, 99] Added predefined palette combination in "database parameters";
    changed presentation of all page.
  - [May 9, 99] Added system to forbid non local accesses.
  - [May 7, 99] Fixed bug: recovering database from old version of GeneWeb
    did not work when the old directory held spaces.
  - [May 7, 99] Fixed bad behavior under Windows: "GWU.EXE" (in uppercase)
    was not regognized when searching for old GeneWeb versions.
  - [May 7, 99] Fixed bug: "cleanup" under Windows did not work.

* GeneWeb  aemon/CGI (gwd)
  - [Jun 7, 99] No more (stupid) abbreviation for "Number" in update forms:
    Did not work for many languages.
  - [Jun 3, 99] Added ability to use a new predefined term "+before" in the
    lexicon to specify the complement is before a verb (e.g. in German:
    "send" "image" is translated into "senden +before" "Bild", which gives
    at end: "Bild senden"; same solution for Dutch).
  - [May 31, 99] In ancestors only selected generation, added displaying
    of Sosa intervals (and "..." is displayed for non-contiguous intervals).
  - [May 18, 99] Added, in ancestors and descendants displaying, the ability
    to cancel GeneWeb links. Useful to extract a Web page for a site without
    GeneWeb server.
  - [May 16, 99] Fixed bug: in ascendants long displaying, did not display
    the last possible generation.
  - [May 15, 99] Added a "?" at end of empty requests (with just the database
    name) because of too smart browsers which automatically add a "/" at end
    of the address in this case (transforming e.g. "http://host/base" into
    "http://host/base/"), what makes the request not working.
  - [May 14, 99] Fixed bug: in personal pages, the term "died" was sometimes
    missing when there was only a death place but no death date. Happened
    for persons born more than 120 years ago.
  - [May 12, 99] Fixed problem in CGI mode under Windows: sometimes displayed
    warning texts on the page.
  - [May 11, 99] Fixed bug: advanced search worked bad when neither "wizard"
    nor "friend": did not work when only specifying e.g. a first name
    or a surname of an existing (non "public") person.
  - [May 11, 99] Fixed bug: when adding ";opt=no_index" in URLs like explained
    in the doc ("How to put links to your base"), the used language was
    missing in the new URL.
  - [May 10, 99] Added ability to put relationship date for non married
    persons.
  - [May 7, 99] Fixed bug visible in Danish: the AE ligature ("&aelig;")
    was incorrectly capitalized.

* Lexicon (lang/lexicon.txt) and welcome pages (*/start.txt)
  - [Jun 7, 99] Changed terms in Dutch for sentences with verb at end.
  - [Jun 7, 99] Added missing terms in Portuguese (Yves Guignard).
  - [Jun 3, 99] Added missing terms in German (Markus Mottl).
  - [Jun 3, 99] Added some missing terms in Italian (Daniel Hirschkoff).
  - [Jun 2, 99] Fixed and completed translations in Swedish (Lars Gustavsson;
    some help also from Stig Petersson).
  - [May 31, 99] Corrected and completed Spanish sentences in lexicon
    and Spanish welcome page (Luis Castro Guzman).

* Gedcom to GeneWeb (ged2gwb)
  - [May 19, 99] Better catenation of continuation (CONC) notes. In particular
    fixes the bug which sometimes added spaces inside words.

* GeneWeb to Gedcom (gwb2ged)
  - [May 19, 99] Fold notes lines at 255 characters (required by GEDCOM
    standard) adding CONC.

* Consanguinity computing (consang)
  - [May 23, 99] Does not restart from scratch when changes: compute
    only what's necessary.

* Documentation
  - [May 13..31, 99] Updated Swedish documentation (Lars Gustavsson).

GeneWeb Version 2.02
--------------------

* New feature

  - [May 4, 99] Added a new program "setup" which will allow to
    use a lot of commands without having to type magic incantations in a
    MSdos (Windows) or Xterm (Unix) window. Everything is done in the Web
    navigator: creation of a database, extraction of a GEDCOM file, cleanup,
    etc etc.
    Should be convenient for non computer scientists beginners (and even for
    old timers computer scientists who already know GeneWeb).

* General
  - [Apr 22, 99] Added Danish language (by Hans Albeck).

* GeneWeb Daemon/CGI (gwd)
  - [May 6, 99] Fixed bad behavior: in "modify person" form, a person was
    not considered as "buried", if the only area filled was "burial place".
  - [May 4, 99] Added button "include missing spouses" for missing ancestors.
  - [May 4, 99] Suppressed trace log count in CGI mode in not redirected
    in a file (option "-log"). Seemed to be incorrectly displayed in the
    HTML page in Windows.
  - [Apr 30, 99] Fixed another accent problem in displaying in clicking
    a first name for corresponding surnames starting with an accentuated
    letter.
  - [Apr 29, 99] Accept now files in image field ending with ".jpeg" and
    ".JPEG" (accepted before only with ".jpg" and ".JPG").
  - [Apr 29, 99] Fixed bug: when a persons first name, last name and number
    is the same as another person, GeneWeb shows a warning and suggests a new
    number. If the new number is selected, all special signs were
    transformed into codes.
  - [Apr 29, 99] Fixed small uncomfortable feature: when trying to save an
    image from a GeneWeb page, the browsers did not propose a correct file
    name to save this image (due to request syntax).
  - [Apr 29, 99] Added ability to change the first name and the surname
    of all children of a person in one only form. See new doc.
  - [Apr 26, 99] Fixed upload of "jpeg" files which sometimes did not work
    with Windows (message: "incorrect request")
  - [Apr 25, 99] Added space before "+" in short dates.

* Lexicon (lexicon.txt)
  - [Apr 23, 99] Some changes in Hebrew version (by Jonathan Marder).

* GeneWeb compiler (gwc)
  - [Apr 22, 99] Do not consider the message "notes before definition"
    any more as a fatal error.

* GeneWeb uncompiler (gwu)
  - [May 3, 99] Added option "-o" for consistency with other commands.
  - [Apr 22, 99] Do not save notes any more for persons having "?" as
    first name or surname.

* Documentation
  - [Apr 29, 99] Added doc for the new feature "change children's names":
    in "update.htm", modified section 3, added a point 5 (shifting the
    point "add parents" to number 6), added section 5.8 for explanations.

GeneWeb Version 2.01
--------------------

* General
  - [Apr 2, 99] Added Norwegian language (Brynjulf Langballe).
  - [Mar 30, 99] Changed term "photo" into "image".

* GeneWeb Daemon/CGI (gwd)
  - [Apr 20, 99] Changed suffix ".cnf" into ".gwf" for configuration files
    (because of confusion with that predefined suffix in Windows).
  - [Apr 20, 99] In short dates (just year), if no birth date, baptism date
    is displayed.
  - [Apr 19, 99] In latest births and latest deaths displaying, the
    dates with just the year or just the month and the year are also taken
    into account.
  - [Apr 17, 99] Improved relationship branches displaying to be readable
    with Lynx (terminal browser without tables).
  - [Apr 16, 99] When merging persons, the lowest number is proposed by
    default.
  - [Apr 16, 99] Added long display for ancestors.
  - [Apr 13, 99] Fixed bug in personal pages: for people having a public
    name, the (small) links to the first name and surname could work
    bad in case of accents. Fixed other bug same kind: in advanced
    request, research did not work if accents were used...
  - [Apr 6, 99] Fixed bug in personal pages, titles dates were sometimes
    displayed just as "...".
  - [Apr 2, 99] Fixed bug: in missing ancestors in alphabetic order, the
    accents in surnames were incorrectly displayed.
  - [Mar 30, 99] Added the spouses when displaying relationship links with
    cousins (from the "cousin" link in personal pages).
  - [Mar 25, 99] Added the "unmarried" case for couples.
  - [Mar 23, 99] Added display of number of accesses in traces.
  - [Mar 17, 99] In person modification form, determines whether a person
    is died or not (if not specified), according to his age.
  - [Mar 16-19, 99] The presence of images in pages does not block any
    more the display of the text. For example, in welcome pages, the text
    does not wait for the displaying of the flags to be displayed, which
    is much more comfortable. (This applies only for local images).
  - [Mar 14, 99] In anniversaries, in the list of months, the selected
    month is now the current month, not always January.

* Gedcom to GeneWeb (ged2gwb)
  - [Apr 2, 99] Added the automatic computation that a person is died or
    not (if not indicated in the gedcom), according to the person's age,
    and deleted the option "-nd".
  - [Mar 31, 99] Added option "-log" to redirect output.
  - [Mar 20, 99] Added options for dates where months are represented by
    numbers: -dates_dm when day before month and -dates_md when month
    before day.
  - [Mar 16, 99] Did not work for gedcom files with white spaces in the
    beginning of the lines. Fixed.
  - [Mar 11, 99] Fixed horrible bug: treatment of accents worked bad for
    gedcom files with ascii charset (resulting problems in "a" umlaut, for
    example).

* Consanguinity computing (consang)
  - [Mar 26, 99] Added option -q for quiet mode, just displaying a progress
    bar.

* Lexicon (lexicon.txt) and Welcome files (xx/start.txt)
  - [Mar 10, 99] Some changes in Italian version (by Raffaele Sena).

* Documentation
  - [Mar 24, 99] Deleted all background colors.
  - [Mar 18..Apr 13, 99] Swedish version updated (Lars Gustavsson).
  - [Mar 17, 99] Changed documentation for the new feature "automatic choice"
    for the "death state" (see above), file "update.htm", section 5.4 "modify
    a person", paragraph "Death".

* Internal
  - [Mar 24, 99] (working Unix only) Added options "-setuid" and "-setgid"
    to "gwd" to change the user or group id after socket bind. This allows
    for example to use the port 80 (root needed) but accessing data as
    normal user.

GeneWeb Version 2.00
--------------------

From the version 2.00, the license is GPL (GNU General Public
License). The previous license still applies up to the version 1.11
included.

* GeneWeb daemon/CGI (gwd)
  - [Mar 7, 99] Added ability to enter directly birth dates for children
    in families forms.
  - [Feb 27, 99] Added case "half-siblings" in relationship links.
  - [Feb 27, 99] In personal pages, titles dates when complete are
    displayed completely (not just year).
  - [Feb 26, 99] For a birth the present day, does not display "happy
    birthday" any more! And displayed age is "birth" and not "less than
    one year".
  - [Feb 26, 99] Displaying of first name alias in personal pages does
    not include the surname any more.
  - [Feb 23, 99] In non leap years, birthday anniversaries of February 29
    are counted and celebrated March 1.
  - [Feb 19, 99] Replacement of "%s" by the name of the base with context,
    also in family comment.
  - [Feb 18, 99] Added deletion of photos.
  - [Feb 13, 99; Feb 20, 99] Added ability to send photos.
  - [Feb 12, 99] Improved displaying in Hebrew language.
  - [Feb 8, 99] Fixed bug in CGI mode under Windows: images (flags e.g.)
    were often truncated.

* Gedcom to GeneWeb (ged2gwb)
  - [Feb 14, 99] Assumed wrongly that all families were defined after
    individuals, because it is often the case in Gedcom files. But this is
    not mandatory in definition Gedcom 5.5. Fixed.
  - [Feb 6, 99] Accept dates with "/" (20/11/1993) although it is not
    standard Gedcom 5.5. Interpreted as day/month/year.

* GeneWeb to Gedcom (gwb2ged)
  - [Feb 26, 99] Fixed error: the first name alias if any was always saved
    in the gedcom as first name. Now saved only as first name if it starts
    with the first name (e.g. if first name = "John" and first name alias =
    "John Philip Robert").

* GeneWeb compiler (gwc)
  - [Feb 19, 99] The option "-cg" did not work. Fixed.

* GeneWeb uncompiler (gwu)
  - [Feb 16, 99] Fixed bug: names holding "?" were sometimes not saved
    correctly, so that gwc did not work afterwards.

* Lexicon
  - [Feb 26, 99] Small change in French translation.
  - [Feb 11, 99..Feb 24, 99] Some changes in Swedish version and fixed some
    errors in English version (Lars Gustavsson).

* Documentation
  - [Mar 8, 99] Added a short paragraph in update.htm, section 5.2,
    paragraph "Filling", alinea "Create" about the fact that one can add his
    birth date.
  - [Feb 26, 99] Small change in French version (translation of "first
    name alias") in file update.htm, section 5.4.
  - [Feb 18, 99] Explained how to delete photos (new feature) in file
    "update.htm", (new) section 5.7. Some more changes in "start.htm",
    section "File a.cnf" and "update.htm" section 3 and 5.6.
  - [Feb 15, 99] Completed info for configuration files in file "start.htm",
    section "File a.cnf". Explained how to send photo (new feature) in file
    "update.htm": added section 5.6, completed section 3.
  - [Feb 11, 99..Feb 24, 99] Updated Swedish version and fixed some errors
    in English version (Lars Gustavsson).
  - [Feb 10, 99] Updated Dutch version (Joris Esch).

GeneWeb Version 1.11
--------------------

* General
  - [Jan 27, 99] Added Hebrew (Jonathan Marder, Ruth Marder)

* GeneWeb daemon/CGI (gwd)
  - [Jan 30, 99] Added link to welcome page after updates.
  - [Jan 24, 99] Added default photo names: not necessary to specify a
    photo for someone, a default name is searched.
  - [Jan 20, 99; Jan 30, 99] Added display of latest deaths.
  - [Jan 19, 99] Added direct links to siblings.
  - [Jan 18, 99] Family comment now displayed like dates (=> possible
    visibility by password restriction).
  - [Jan 18, 99] In notes and sources, the string "%s" is replaced by the
    name of the base in the same context. For example, in a source field,
    if "John Smith" is in the same database, it is possible to record it
    as:
      <a href="%sp=john;n=smith">John Smith</a>
  - [Jan 11, 99] Display declined forms (for some languages). E.g.:
      * in German: "x ist ein Sohn von einem Cousin von y"
    ("einem" instead of the inkorrect "ein").
      * in Esperanto: "aldoni personon"
          ("personon" instead of the incorrect "persono")

* GeneWeb compiler (gwc)
  - [Jan 26, 99] Fixed bug: failure when backslashes in source.
  - [Jan 18, 99] Fixed two bugs in dates parsing: 1. "x..y" (between x and
    y) was interpreted as "x|y" (x or y) 2. did not accept "d/m/y..y".

* Gedcom to GeneWeb (ged2gwb)
  - [Feb 3, 99] No more message "Not implemented SUBM".
  - [Feb 1, 99] Accept now "BET x AND" as "AFT x" and "BET AND x" as "BEF x".
  - [Feb 1, 99] Fixed bug: date intervals did not work (generating "maybe").

* GeneWeb to Gedcom (gwb2ged)
  - [Jan 19, 99] Fixed bug: the tag "<br>" was converted into a new line
    only in lowercase form; "<BR>" did not work.

* Gedcom to GeneWeb and GeneWeb to Gedcom (ged2gwb, gwb2ged)
  - [Jan 18, 99] When there are several names (several records "1 NAME") for
    someone in Gedcom, the other become "aliases" (and vice versa for
    gwb2ged).

* GeneWeb uncompiler (gwu)
  - [Feb 4, 99] Notes for persons having "?" no more saved (these
    persons are supposed to be deadends and this made "gwc" fail).

* Lexicon file (lexicon.txt)
  - [Feb 3, 99] Some changes in Swedish translation (Lars Gustavsson).
  - [Jan 28, 99] Added section "!dir" for languages written right to left.
  - [Jan 28, 99] [minor] Portuguese translation now in pure ascii using
    HTML "&" macros instead of accents (no changes in Portuguese displaying)
  - [Jan 16, 99] For update forms, changed text "Date" into "Date (d/m/y)"
    in english version to be sure there is no ambiguity.
  - [Jan 16, 99] Added declined forms.
  - [Jan 16, 99] Fixed typos in German version (Markus Mottl).

* Welcome files (xx/start.txt)
  - [Jan 30, 99] (en) Some changes in terms used (anniversaries).

* Documentation
  - [Feb 3, 99] Added a paragraph (Message "socket failed") in "problems".
  - [Feb 1, 99] Updated Dutch version (Joris Esch).
  - [Jan 29, 99] Added remark at end of introduction for how to redirect
    the command displaying in a file.
  - [Jan 26, 99..Feb 3, 99] Fixed many typos in english version (Lars
    Gustavsson).
  - [Jan 25, 99] Added doc explaining consanguinity: new link in "directions
    for use".
  - [Jan 24, 99] Added doc for default photo name (new feature) in "directions
    for use", page "modifications", section 5.4 ("modify a person"),
    paragraph "Photo".
  - [Jan 24, 99] Fixed typo; was indicated "image" instead of "images" as
    directory name in this paragraph.
  - [Jan 22, 99] Added a few lines for "How to merge two families" in the
    page "modifications".
  - [Jan 20, 99] Added documentation for:
      * how to put links to GeneWeb databases.
      * how to customize welcome pages.
  - [Jan 11, 99] Swedish version (Lars Gustavsson).

GeneWeb Version 1.10
--------------------

* GeneWeb daemon/CGI (gwd)
  - [09/01/99] Fixed bug in CGI mode: images in directory "images/base"
    were sometimes not found.
  - [08/01/99] Changed term "consanguinity" into "relationship" in
    relationship computing (because confusion with the usual meaning of
    the term "consanguinity").
  - [06/01/99] Deleted Unix option "-robot_xcl": worked bad, did not detect
    robots, detected robots when there are not, too complicated to fix.
    (The normal HTTP robot exclusion remains.)
  - [28/12/98] Changed some http requests to hold no accents (should be
    continued...)
  - [19/12/98] Fixed bug quotes disappearing in field "first name aliases"
    in form Update/Person (if the value holds quotes).
  - [18/12/98] No more HTML "table" used in relationship links with
    one branch (=> more compact display and visible in browsers
    without tables, e.g. "lynx").
  - [13/12/98] The directory cnt is no more searched in the directory where
    the daemon (or the CGI) is launched but in the base directory (option -bd
    of gwd; no difference if option -bd not used).
  - [13/12/98] In relationship links, display the ancestor couple (if both
    are ancestors).
--- [12/12/98..13/12/98] Added displaying of cousins.
  - [11/12/98] Fixed more bugs (accents) due to new ANSEL encoding.

* Gedcom to GeneWeb (ged2gwb)
  - [14/12/98] Fixed bug in Windows version (displaying "uncaught exception:
    Stream.Failure").

* GeneWeb compiler (gwc)
  - [02/01/99] Fixed missing accents displaying for undefined persons.

* Lexicon file (lexicon.txt)
  - [06/01/99] Fixed and completed German version (thanks to Markus Mottl).
  - [15/12/98] Added some missing phrases in some languages (mainly Espagnol,
    Italian).
  - [11/12/98] Fixed and completed Dutch version (thanks to Joris Esch).

* Welcome files (xx/start.txt)
--- [06/01/99, 08/01/99] <font color=red>Wizard and Friend passwords
    are to be provided in a popped window</font> (except in CGI mode).
  - [04/01/99, 09/01/99] (de) Fixed some typo (thanks to Markus Mottl).
  - [11/12/98, 04/01/99] (nl) Fixed and completed (thanks to Joris Esch).

* GeneWeb uncompiler (gwu)
  - [12/12/98] Added option "-mem" to save memory space, but slower.

* Documentation
  - [09/01/99] Changed link to "LICENCE" which did not always work.
--- [04/01/99] Added dutch version (thanks to Joris Esch).

GeneWeb Version 1.09
--------------------

* Inside databases
--- Precisions of dates now apply not only for years, but for complete
    date. E.g. "maybe on september 1815" or "after september 23, 1815".
--- In dates, added case "between": between year and another year.
  - Structure of databases have been changed for these two above points.
  - Area "comment" in families is now kept even if there are children.

* Gedcom to GeneWeb (ged2gwb)
  - Delete of duplicated FAMS which sometimes happen in erroneous Gedcoms.
  - Delete families from GEDCOM when parents don't have the good sex.
  - Added displaying of line number when syntax errors and unrecognized dates.
  - Get sources if defined by pointer (but just the 1st line).
  - Added option "-no_nd" (no negative dates), not to interpret years preceded
    by a minus sign as negative dates.

* GeneWeb to Gedcom (gwb2ged)
  - Added option "-ascii" to output in ASCII encoding instead of ANSEL.

* Gedcom to GeneWeb and GeneWeb to Gedcom (ged2gwb, gwb2ged)
  - The <em>GeneWeb</em> fields "public name", "surname alias" and
    "photo" are now loaded from and saved to Gedcom resp. as: "2 GIVN",
    "2 SURN" and "1 OBJE (newline) 2 FILE".

* GeneWeb daemon/CGI (gwd)
--- Added alibity to specify someone as Sosa reference. Then the Sosa
    number is printed in navigation when displaying ancestors. Thanks to
    Emmanuelle Visseaux for this idea.
--- Restructuration of displaying of surnames and first names by alphabetic
    order and frequency. Fixed bug of bad alphabetic order when first names
    and surnames with accents. Access in indexes faster.
  - In list by title places, added clickable "The whole list" giving the
    list of all persons associated with this place, whatever the title.
  - Descendants display limited to 12 generations in all cases (else too much
    text or too long to answer).
  - Added error message in relationship computing when loop in
    database (someone being his/her own ancestor).
  - In "search", added ability to write "I" instead of "Ier" (french form).
    Ex: "Charles I" or "Charles Ier" are both accepted.
  - Added ability to add ";opt=no_index" at end of requests to get an
    equivalent link independent from the persons' index number (useful
    to put direct links in Web pages).
  - Added text "Parents of" in top of pages of missing ancestors.
  - Fixed still several bugs (accents) due to new ANSEL encoding.

* Base configuration files (xxx.cnf)
  - Added variable "wizard_just_friend" to suspend the powers of
    "wizards" (e.g. for maintenance): when set to "yes", they become
    simple "friends" (default: "no").
  - Variable "renamed" can be used to specify that a database has been
    renamed. Generates a page giving the good URL to use.

* GeneWeb compiler and Consanguinity computing (gwc, consang)
  - Fixed accents displaying in traces and error messages.

* Welcome pages (start.txt)
  - Fixed wrong displaying of number of accesses in spanish (es) and
    portuguese (pt) versions.
  - Display thousand separators in numbers of accesses.

* Documentation (directory doc)
  - Added 2 cases in FAQ.
  - Many small changes.

GeneWeb Version 1.08
--------------------

* Added portuguese among languages (thanks to Yves Guignard).

* gwd:
  - fixed several displaying bugs due to ANSEL
  - in forms, when a precision (about, maybe, before, after, or year) is given
    for a date, the day and month part are ignored, since its works only for
    years (for the moment).
  - photos and background in directory "images" can be installed in a
    subdirectory having the name of the database; ex: "images/martin" for
    the database "martin".
  - display "+" for dead people even if not known date

* gwc, gwu:
  - added backslash as escape character for underscores

* gwc:
  - save much much memory space while running when there are many many notes

* ged2gwb:
  - fixed bug displaying "Uncaught exception: Stream.Error("get to eoln")" when
    the gedcom file did not end with a newline

* consang:
  - more clear message when consang does not work because of loop in database

* doc:
  - added doc for merging databases, persons and families.
  - added doc for databases maintenance.
  - small changes in diruse.htm, server.htm, start.htm

GeneWeb Version 1.07
--------------------

* Added some stuff to allow chinese like languages.
* Started chinese translation
* Added source field for birth, baptism, death, burial, marriage.

* gwd:
  - fixed bug, missing ancestors were printed in reverse order
  - fixed bug, could not find file "start.txt" in -hd directory.
  - fixed bug, missing persons when displaying close names
  - used flags for languages selection instead of tables
  - better displaying of dates for the miscellaneous languages
  - display birthdays of persons with death "don't know" (but without age)

* ged2gwb:
  - does not stop any more when bad GEDCOM line found => warning and goes on.
  - added option -nd setting flag "not dead" instead of "don't know if dead"
    for personal records where "DEAT" exists but is empty.

* gwb2ged:
  - start now pointers with 1 instead of 0 because some software seem not
    to accept @I0@ and @F0@.
  - generate always ANSEL encoding

* gwu:
  - added option -d to select descendants like in gwb2ged

GeneWeb Version 1.06
--------------------

* ged2gwb:
  - warning, not error now, when a person is undefined
* a.cnf:
  - added example of setting background image

GeneWeb Version 1.05
--------------------

* gwd:
  - added ability to merge persons and families.
  - added advanced requests
  - added year interval when displaying missing ancestors
  - (detail) added dates when displaying descendants indexes.
  - (detail) misc terms changing ("add"->"insert"; "nickname"->"qualifier"...)

* gwu:
  - added option "-a" to select ancestors like in command "gwb2ged".

* bug fixes:
  - Fixed a problem of blocking: the symptom was that, in some
    versions of Windows 95, "gwd" started normally, but when opening
    the site in the navigator, the site was found but the navigator was
    waiting and waiting forever.
  - When updating a person, if the "notes" field holds only a newline,
    the request is rejected => fixed. Moreover some browsers add this "bad"
    newline if the notes fields is empty => fixed.

GeneWeb Version 1.04
--------------------

* gwd, ged2gwb, gwb2ged:
  - added baptism (separated from birth) and burial/cremation.
  - added sources for marriages.

* gwd:
  - added "access" info, for infos display when dates < now - 100 years =
    * "If Titles" => displayed if the person has titles
    * "Public"    => always displayed
    * "Private"   => not displayed
  - added link to welcome page in personal record pages.
  - added option -auth: authorization file to restrict access (password)
  - fixed bug: in cgi mode, access to images did not work.
  - in welcome page, date (since ...) is printed in original language.
  - birthday months displayed as a menu and at the end instead of beginning

* lexicon.txt:
  - some changes in translations

GeneWeb Version 1.03
--------------------

* Added swedish version.

* gwd:
  - in display by name, display year with precision in marriages
  - in missing ancestors by alphabetic order, display spouses too
  - in missing ancestors by Soza, shorter display of numbers
  - changed syntax of gwd.arg file (for cgi mode) => see doc "server"
  - in update person form, display "born" and "died" in neutral when
    language can do it (e.g. french "ne(e)", "decede(e)")
  - added request m=R;p=..;n=..;p1=..;n1=.. displaying relationship
    between two persons by their names

* ged2gwb:
  - when converting a date with qualifier, if the date holds day or month,
    converts into: "ca Year". Ex: "AFT APR 1218" is read as "ABT 1218".
  - fixed bug: date 16/2/1964 gave "year = 16" instead of "year = 1964"

* gwd, a.cnf, lang/lexicon.txt
  - deleted principle of "message" (was undocumented, anyway)

* gwd, doc:
  - changed terminology "occurrence number" into just "number" (I realized
    that "occurrence" is mathematical jargon).

* gwd, lang/*/start.txt:
  - displaying of total number of accesses, not only accesses in welcome page

* in all commands:
  - options -help display message on standard output instead of standard
    error, allowing to use "| more" in Windows 95/NT

GeneWeb Version 1.02
--------------------

* doc:
  - explain a solution for the problem of connection off line

* ged2gwb:
  - ANSEL encoding is automatically detected (1 CHAR ANSEL in GEDCOM).
    Suppression option "-tma"; adding "-ansel" and "-no_ansel" to force
    or suppress the encoding, overriding the possible setting in GEDCOM.

* gwd:
  - fixed bug: error while treating anniversaries of marriage in
    databases where families had been deleted:
       Uncaught exception: Failure("access persons out of bounds")

GeneWeb Version 1.01
--------------------

New:

- Command gwb2ged to export GEDCOM files.
- More doc

Other changes:

* ged2gwb:
  - accept BAPM (unspecified baptism) together with CHR (christian baptism)
    in individual records
  - treat fields TITL (nobility titles) in individual records
  - fixed bug: families and children was bad ordered or reordered
  - added field SOUR (sources) (if not a pointer) for personal record; was
    only selected from BIRT (birth) and DEAT (death)
  - options -epn and -efn are now by default: options -no_epn and -no_efn
    added to cancel thems.
  - applies "-lf" after "-epn"

* gwd:
  - changed: when deleting a person, it is now deleted also among the
    children of his parents.
  - fixed bug: when deleting a person, some fields were not erased.
  - added option -lang: default language
  - changed: displaying shortcuts when accessing by titles: for example,
    if there is only one king in the database, and it is "king of France",
    selecting "king" directly displays "kings of France".

* gwb2gw has been renamed gwu.

GeneWeb Version 1.0
-------------------

CGI mode is Ok.

* gwd, ged2gwb, lang/lexicon.txt:
  - errors on dates become warnings

GeneWeb Version 1.0-beta.10
---------------------------

Still intermediate version to perfect "CGI" mode.

* gwd:
  - fixed bug: update did not work in cgi mode.
  - print person link after "family switch"
  - when using "add parents", surname is printed in child area => ability
    to change father's.

GeneWeb Version 1.0 beta.9
--------------------------

Intermediate version to perfect "CGI" mode under Windows NT.

* More documentation

* gwd:
  - cgi is detected by the presence of environment variable QUERY_STRING.
    It seems that .bat files is not accepted in Web servers in Windows NT,
    so one must use "gwd" itself.
  - if "gwd" is installed in cgi directory, and is renamed, e.g. "geneweb.exe",
    ability to add a file named "geneweb.arg" holding some lines
       * the first line if existing holds the name of the directory
            where "lang" is installed
       * the second line if existing holds the name of the directory
            where the databases are installed
       * the third line, if existing, may hold the string "cgi" telling
            that gwd must run on "cgi" mode, even if QUERY_STRING is
            not set
  - added option -bd: bases directory
  - no error message now if background not found

* Deleted "add/person" in update (gwd) and in welcome pages (lang/*/start.txt)
  => impossibility now to directly create isolated persons. This is because
  it often leads to manipulation errors. To add a new baby, use "modify
  family" from one of his parents' personal record.

GeneWeb Version 1.0 beta.8
--------------------------

* Added documentation in HTML: directions for use
* Added LICENCE
* Deleted COMM-en.txt & COMM-fr.txt

* gwd:
  - added cgi mode (option -cgi)
  - Less general for access by approximative spelling: ex: first name "agns"
    will not yet answer: "Agnes" and "Gunza", but just "Agnes".
  - Unix version: time out limited to 120 seconds instead of 60
  - Descendants by list limited to 8 instead of 5
  - added missing divorce information in descendants by list
  - Fixed bug: Ok on "add person" did not work
  - Fixed bug: could not cancel a friend or wizard password, by giving an
    empty one in the form in starting page
  - Fixed bug: shift at end of page for the indexes of descendants.
  - Fixed bug: update of family did not work.

* ged2gwb:
  - added divorces
  - suppressed sources when forward defined (code reorganizing to do).

* lang/lexicon.txt:
  - german translation updated

* lang/de/start.txt:
  - german translation updated

GeneWeb Version 1.0 beta.7
--------------------------

* general:
  - changed bases representation => memory consummation reduced in gwd and
    in consang
  - negative years are treated (gwc, gwd, ged2gwb)
* gwd:
  - the directory cnt holding counts is searched in the current directory
    not in the one given by option "-hd" (no difference if -hd not specified).
  - this directory, cnt, is created if no present
  - ability to add a file "foo.trl" for the base "foo", in lang directory
    and in its subdirectories: the file is inserted at the end of all pages
    after the GeneWeb copyright. Note: the files ".txt" in the
    subdirectories do not hold yet the final tag "</body>".
  - limitation to 5 generations for descendants display in list format
  - fixed bug: families could be displayed twice in case of close surnames
  - fixed bug: displaying of lexicon worked bad in 1.0-beta.6
* gwb2gw:
  - memory consummation significantly reduced
  - added option -tnd: infer negative dates when missing minus signs in GEDCOM
  - added option -lf: lowercase first names
  - add file "command.txt" in base directory to remind the used command and
    arguments
  - fixed bug: when multiple lines with 1 NOTES, only the first was treated
  - fixed bug: names starting with special letters were truncated
  - fixed bug: better search for possible years in undecoded dates

GeneWeb Version 1.0 beta.6
--------------------------

* ged2gwb:
  - now only shortcut for options, suppressed long versions, finally
  - fixed bug in option "-tma" creating sometimes strings of bad length
  - fixed bug sometimes omissions of recording notes
  - try to find a year (a number between 32 and 2500) in dates impossible
    to decode
* gwd:
  - added option "-only" in version Windows 95 too.
  - added option "-log" in version Windows 95 to redirect log to a file.
  - added display of ascendants up to an ancestor in relationship computing.
  - while displaying ascendants, the first generation is now the person
    himself (which is displayed with Soza number 1), not his parents
  - accept local ".GIF" files as photos (up to now, it was only ".gif", ".jpg"
    and ".JPG").
  - local photo files are searched in (new) directory "images"
  - added copyright (c)
* gwc
  - options described in english
  - added "unnamed" in statistics (option -stats)
* lang/lexicon.txt:
  - some fixes in dutch version
* lang/version:
  - added copyright (c)
* lang/*/start.txt:
  - added form at end of pages to allow entering password for other entries.

GeneWeb Version 1.0 beta.5
--------------------------

Main changes

* ged2gwb:
  - added option "-translate_msdos_accents"
  - added shortcuts for options => -ls -efn -epn -tma
  - errors go to standard output instead of standard error
* gwd:
  - missing ancestors:
    o added alphabetic order
    o no more display of spouses
    o proposed for all entries (not only for wizard one)
  - added "From inet_addr" in traces in Windows NT/95.
  - added date of service start in starting files.
  - fixed bug: internal error after: relationship computing => selection by
    name => alphabetic order
* lang/lexicon.txt
  - completed translations in german and spanish

Secondary changes

* gwd:
  - added more explicit messages for some system errors.
  - changed the text "numbers" into "Soza numbers" in ancestors.
  - changed surnames display in alphabetic order (particles after)
  - improve messages in relationship links ("click here to see the first
    branch")
  - signature version of GeneWeb in default starting pages

GeneWeb Version 1.0 beta.4
--------------------------

* ged2gwb:
  - fixed bug: tag DEAT generated "dead" in some wrong cases.
  - options "-extract_first_name" and "-extract_public_name" more separated
    and working better
* gwd:
  - There was another problem of blocking. Fixed (supposed to!).
* a.cnf:
  - palette of colors is proposed

GeneWeb Version 1.0 beta.3
--------------------------

* ged2gwb:
   Options
    - option "-uncapitalize" is renamed "-lowercase_surnames"
    - Added options "-extract_first_names" and "-extract_public_names"
   Behaviour:
    - Newlines (<br>) added in notes when CONT.
    - Field NAME of the form "/ NAME / first name" correctly treated
    - Field CHR (baptism) taken into account.
    - Several fields "1 OCCU" treated.
    - Field SOUR is now only if directly in the line (not reference)
* consang:
  - recompute all consanguinity in base if family updates has been done
* gwd:
  - added possibility of nth in titles (ex: 3rd earl of ...)
  - displaying of baptism in short dates, if not birth date
  - thousand separation in numbers depending on the language (comma in
    english, dot in french, etc).
  - fixed bug in Win 95 version: blocks from time to time
